/*
    Last Release: 23/4/2018 @ 16:31:22
    Author:  IndoDevApps
    Version:  1.0.2
*/
!function(global, factory) {
    "object" === typeof exports && "undefined" !== typeof module ? module.exports = factory() : "function" === typeof define && define.amd ? define(factory) : global.moment = factory();
}(this, function() {
    "use strict";
    var hookCallback;
    function hooks() {
        return hookCallback.apply(null, arguments);
    }
    function setHookCallback(callback) {
        hookCallback = callback;
    }
    function isArray(input) {
        return input instanceof Array || "[object Array]" === Object.prototype.toString.call(input);
    }
    function isObject(input) {
        return null != input && "[object Object]" === Object.prototype.toString.call(input);
    }
    function isObjectEmpty(obj) {
        if (Object.getOwnPropertyNames) return 0 === Object.getOwnPropertyNames(obj).length; else {
            var k;
            for (k in obj) if (obj.hasOwnProperty(k)) return false;
            return true;
        }
    }
    function isUndefined(input) {
        return void 0 === input;
    }
    function isNumber(input) {
        return "number" === typeof input || "[object Number]" === Object.prototype.toString.call(input);
    }
    function isDate(input) {
        return input instanceof Date || "[object Date]" === Object.prototype.toString.call(input);
    }
    function map(arr, fn) {
        var i, res = [];
        for (i = 0; i < arr.length; ++i) res.push(fn(arr[i], i));
        return res;
    }
    function hasOwnProp(a, b) {
        return Object.prototype.hasOwnProperty.call(a, b);
    }
    function extend(a, b) {
        for (var i in b) if (hasOwnProp(b, i)) a[i] = b[i];
        if (hasOwnProp(b, "toString")) a.toString = b.toString;
        if (hasOwnProp(b, "valueOf")) a.valueOf = b.valueOf;
        return a;
    }
    function createUTC(input, format, locale, strict) {
        return createLocalOrUTC(input, format, locale, strict, true).utc();
    }
    function defaultParsingFlags() {
        return {
            empty: false,
            unusedTokens: [],
            unusedInput: [],
            overflow: -2,
            charsLeftOver: 0,
            nullInput: false,
            invalidMonth: null,
            invalidFormat: false,
            userInvalidated: false,
            iso: false,
            parsedDateParts: [],
            meridiem: null,
            rfc2822: false,
            weekdayMismatch: false
        };
    }
    function getParsingFlags(m) {
        if (null == m._pf) m._pf = defaultParsingFlags();
        return m._pf;
    }
    var some;
    if (Array.prototype.some) some = Array.prototype.some; else some = function(fun) {
        var t = Object(this);
        var len = t.length >>> 0;
        for (var i = 0; i < len; i++) if (i in t && fun.call(this, t[i], i, t)) return true;
        return false;
    };
    function isValid(m) {
        if (null == m._isValid) {
            var flags = getParsingFlags(m);
            var parsedParts = some.call(flags.parsedDateParts, function(i) {
                return null != i;
            });
            var isNowValid = !isNaN(m._d.getTime()) && flags.overflow < 0 && !flags.empty && !flags.invalidMonth && !flags.invalidWeekday && !flags.weekdayMismatch && !flags.nullInput && !flags.invalidFormat && !flags.userInvalidated && (!flags.meridiem || flags.meridiem && parsedParts);
            if (m._strict) isNowValid = isNowValid && 0 === flags.charsLeftOver && 0 === flags.unusedTokens.length && void 0 === flags.bigHour;
            if (null == Object.isFrozen || !Object.isFrozen(m)) m._isValid = isNowValid; else return isNowValid;
        }
        return m._isValid;
    }
    function createInvalid(flags) {
        var m = createUTC(NaN);
        if (null != flags) extend(getParsingFlags(m), flags); else getParsingFlags(m).userInvalidated = true;
        return m;
    }
    var momentProperties = hooks.momentProperties = [];
    function copyConfig(to, from) {
        var i, prop, val;
        if (!isUndefined(from._isAMomentObject)) to._isAMomentObject = from._isAMomentObject;
        if (!isUndefined(from._i)) to._i = from._i;
        if (!isUndefined(from._f)) to._f = from._f;
        if (!isUndefined(from._l)) to._l = from._l;
        if (!isUndefined(from._strict)) to._strict = from._strict;
        if (!isUndefined(from._tzm)) to._tzm = from._tzm;
        if (!isUndefined(from._isUTC)) to._isUTC = from._isUTC;
        if (!isUndefined(from._offset)) to._offset = from._offset;
        if (!isUndefined(from._pf)) to._pf = getParsingFlags(from);
        if (!isUndefined(from._locale)) to._locale = from._locale;
        if (momentProperties.length > 0) for (i = 0; i < momentProperties.length; i++) if (prop = momentProperties[i], 
        val = from[prop], !isUndefined(val)) to[prop] = val;
        return to;
    }
    var updateInProgress = false;
    function Moment(config) {
        if (copyConfig(this, config), this._d = new Date(null != config._d ? config._d.getTime() : NaN), 
        !this.isValid()) this._d = new Date(NaN);
        if (false === updateInProgress) updateInProgress = true, hooks.updateOffset(this), 
        updateInProgress = false;
    }
    function isMoment(obj) {
        return obj instanceof Moment || null != obj && null != obj._isAMomentObject;
    }
    function absFloor(number) {
        if (number < 0) return Math.ceil(number) || 0; else return Math.floor(number);
    }
    function toInt(argumentForCoercion) {
        var coercedNumber = +argumentForCoercion, value = 0;
        if (0 !== coercedNumber && isFinite(coercedNumber)) value = absFloor(coercedNumber);
        return value;
    }
    function compareArrays(array1, array2, dontConvert) {
        var i, len = Math.min(array1.length, array2.length), lengthDiff = Math.abs(array1.length - array2.length), diffs = 0;
        for (i = 0; i < len; i++) if (dontConvert && array1[i] !== array2[i] || !dontConvert && toInt(array1[i]) !== toInt(array2[i])) diffs++;
        return diffs + lengthDiff;
    }
    function warn(msg) {
        if (false === hooks.suppressDeprecationWarnings && "undefined" !== typeof console && console.warn) void 0;
    }
    function deprecate(msg, fn) {
        var firstTime = true;
        return extend(function() {
            if (null != hooks.deprecationHandler) hooks.deprecationHandler(null, msg);
            if (firstTime) {
                var args = [];
                var arg;
                for (var i = 0; i < arguments.length; i++) {
                    if (arg = "", "object" === typeof arguments[i]) {
                        for (var key in arg += "\n[" + i + "] ", arguments[0]) arg += key + ": " + arguments[0][key] + ", ";
                        arg = arg.slice(0, -2);
                    } else arg = arguments[i];
                    args.push(arg);
                }
                warn(msg + "\nArguments: " + Array.prototype.slice.call(args).join("") + "\n" + new Error().stack), 
                firstTime = false;
            }
            return fn.apply(this, arguments);
        }, fn);
    }
    var deprecations = {};
    function deprecateSimple(name, msg) {
        if (null != hooks.deprecationHandler) hooks.deprecationHandler(name, msg);
        if (!deprecations[name]) warn(msg), deprecations[name] = true;
    }
    function isFunction(input) {
        return input instanceof Function || "[object Function]" === Object.prototype.toString.call(input);
    }
    function set(config) {
        var prop, i;
        for (i in config) if (prop = config[i], isFunction(prop)) this[i] = prop; else this["_" + i] = prop;
        this._config = config, this._dayOfMonthOrdinalParseLenient = new RegExp((this._dayOfMonthOrdinalParse.source || this._ordinalParse.source) + "|" + /\d{1,2}/.source);
    }
    function mergeConfigs(parentConfig, childConfig) {
        var prop, res = extend({}, parentConfig);
        for (prop in childConfig) if (hasOwnProp(childConfig, prop)) if (isObject(parentConfig[prop]) && isObject(childConfig[prop])) res[prop] = {}, 
        extend(res[prop], parentConfig[prop]), extend(res[prop], childConfig[prop]); else if (null != childConfig[prop]) res[prop] = childConfig[prop]; else delete res[prop];
        for (prop in parentConfig) if (hasOwnProp(parentConfig, prop) && !hasOwnProp(childConfig, prop) && isObject(parentConfig[prop])) res[prop] = extend({}, res[prop]);
        return res;
    }
    function Locale(config) {
        if (null != config) this.set(config);
    }
    var keys;
    if (hooks.suppressDeprecationWarnings = false, hooks.deprecationHandler = null, 
    Object.keys) keys = Object.keys; else keys = function(obj) {
        var i, res = [];
        for (i in obj) if (hasOwnProp(obj, i)) res.push(i);
        return res;
    };
    var defaultCalendar = {
        sameDay: "[Today at] LT",
        nextDay: "[Tomorrow at] LT",
        nextWeek: "dddd [at] LT",
        lastDay: "[Yesterday at] LT",
        lastWeek: "[Last] dddd [at] LT",
        sameElse: "L"
    };
    function calendar(key, mom, now) {
        var output = this._calendar[key] || this._calendar["sameElse"];
        return isFunction(output) ? output.call(mom, now) : output;
    }
    var defaultLongDateFormat = {
        LTS: "h:mm:ss A",
        LT: "h:mm A",
        L: "MM/DD/YYYY",
        LL: "MMMM D, YYYY",
        LLL: "MMMM D, YYYY h:mm A",
        LLLL: "dddd, MMMM D, YYYY h:mm A"
    };
    function longDateFormat(key) {
        var format = this._longDateFormat[key], formatUpper = this._longDateFormat[key.toUpperCase()];
        if (format || !formatUpper) return format; else return this._longDateFormat[key] = formatUpper.replace(/MMMM|MM|DD|dddd/g, function(val) {
            return val.slice(1);
        }), this._longDateFormat[key];
    }
    var defaultInvalidDate = "Invalid date";
    function invalidDate() {
        return this._invalidDate;
    }
    var defaultOrdinal = "%d";
    var defaultDayOfMonthOrdinalParse = /\d{1,2}/;
    function ordinal(number) {
        return this._ordinal.replace("%d", number);
    }
    var defaultRelativeTime = {
        future: "in %s",
        past: "%s ago",
        s: "a few seconds",
        ss: "%d seconds",
        m: "a minute",
        mm: "%d minutes",
        h: "an hour",
        hh: "%d hours",
        d: "a day",
        dd: "%d days",
        M: "a month",
        MM: "%d months",
        y: "a year",
        yy: "%d years"
    };
    function relativeTime(number, withoutSuffix, string, isFuture) {
        var output = this._relativeTime[string];
        return isFunction(output) ? output(number, withoutSuffix, string, isFuture) : output.replace(/%d/i, number);
    }
    function pastFuture(diff, output) {
        var format = this._relativeTime[diff > 0 ? "future" : "past"];
        return isFunction(format) ? format(output) : format.replace(/%s/i, output);
    }
    var aliases = {};
    function addUnitAlias(unit, shorthand) {
        var lowerCase = unit.toLowerCase();
        aliases[lowerCase] = aliases[lowerCase + "s"] = aliases[shorthand] = unit;
    }
    function normalizeUnits(units) {
        return "string" === typeof units ? aliases[units] || aliases[units.toLowerCase()] : void 0;
    }
    function normalizeObjectUnits(inputObject) {
        var normalizedProp, prop, normalizedInput = {};
        for (prop in inputObject) if (hasOwnProp(inputObject, prop)) if (normalizedProp = normalizeUnits(prop), 
        normalizedProp) normalizedInput[normalizedProp] = inputObject[prop];
        return normalizedInput;
    }
    var priorities = {};
    function addUnitPriority(unit, priority) {
        priorities[unit] = priority;
    }
    function getPrioritizedUnits(unitsObj) {
        var units = [];
        for (var u in unitsObj) units.push({
            unit: u,
            priority: priorities[u]
        });
        return units.sort(function(a, b) {
            return a.priority - b.priority;
        }), units;
    }
    function zeroFill(number, targetLength, forceSign) {
        var absNumber = "" + Math.abs(number), zerosToFill = targetLength - absNumber.length, sign = number >= 0;
        return (sign ? forceSign ? "+" : "" : "-") + Math.pow(10, Math.max(0, zerosToFill)).toString().substr(1) + absNumber;
    }
    var formattingTokens = /(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g;
    var localFormattingTokens = /(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g;
    var formatFunctions = {};
    var formatTokenFunctions = {};
    function addFormatToken(token, padded, ordinal, callback) {
        var func = callback;
        if ("string" === typeof callback) func = function() {
            return this[callback]();
        };
        if (token) formatTokenFunctions[token] = func;
        if (padded) formatTokenFunctions[padded[0]] = function() {
            return zeroFill(func.apply(this, arguments), padded[1], padded[2]);
        };
        if (ordinal) formatTokenFunctions[ordinal] = function() {
            return this.localeData().ordinal(func.apply(this, arguments), token);
        };
    }
    function removeFormattingTokens(input) {
        if (input.match(/\[[\s\S]/)) return input.replace(/^\[|\]$/g, ""); else return input.replace(/\\/g, "");
    }
    function makeFormatFunction(format) {
        var i, length, array = format.match(formattingTokens);
        for (i = 0, length = array.length; i < length; i++) if (formatTokenFunctions[array[i]]) array[i] = formatTokenFunctions[array[i]]; else array[i] = removeFormattingTokens(array[i]);
        return function(mom) {
            var i, output = "";
            for (i = 0; i < length; i++) output += isFunction(array[i]) ? array[i].call(mom, format) : array[i];
            return output;
        };
    }
    function formatMoment(m, format) {
        if (!m.isValid()) return m.localeData().invalidDate(); else return format = expandFormat(format, m.localeData()), 
        formatFunctions[format] = formatFunctions[format] || makeFormatFunction(format), 
        formatFunctions[format](m);
    }
    function expandFormat(format, locale) {
        var i = 5;
        function replaceLongDateFormatTokens(input) {
            return locale.longDateFormat(input) || input;
        }
        for (localFormattingTokens.lastIndex = 0; i >= 0 && localFormattingTokens.test(format); ) format = format.replace(localFormattingTokens, replaceLongDateFormatTokens), 
        localFormattingTokens.lastIndex = 0, i -= 1;
        return format;
    }
    var match1 = /\d/;
    var match2 = /\d\d/;
    var match3 = /\d{3}/;
    var match4 = /\d{4}/;
    var match6 = /[+-]?\d{6}/;
    var match1to2 = /\d\d?/;
    var match3to4 = /\d\d\d\d?/;
    var match5to6 = /\d\d\d\d\d\d?/;
    var match1to3 = /\d{1,3}/;
    var match1to4 = /\d{1,4}/;
    var match1to6 = /[+-]?\d{1,6}/;
    var matchUnsigned = /\d+/;
    var matchSigned = /[+-]?\d+/;
    var matchOffset = /Z|[+-]\d\d:?\d\d/gi;
    var matchShortOffset = /Z|[+-]\d\d(?::?\d\d)?/gi;
    var matchTimestamp = /[+-]?\d+(\.\d{1,3})?/;
    var matchWord = /[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i;
    var regexes = {};
    function addRegexToken(token, regex, strictRegex) {
        regexes[token] = isFunction(regex) ? regex : function(isStrict, localeData) {
            return isStrict && strictRegex ? strictRegex : regex;
        };
    }
    function getParseRegexForToken(token, config) {
        if (!hasOwnProp(regexes, token)) return new RegExp(unescapeFormat(token)); else return regexes[token](config._strict, config._locale);
    }
    function unescapeFormat(s) {
        return regexEscape(s.replace("\\", "").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g, function(matched, p1, p2, p3, p4) {
            return p1 || p2 || p3 || p4;
        }));
    }
    function regexEscape(s) {
        return s.replace(/[-\/\\^$*+?.()|[\]{}]/g, "\\$&");
    }
    var tokens = {};
    function addParseToken(token, callback) {
        var i, func = callback;
        if ("string" === typeof token) token = [ token ];
        if (isNumber(callback)) func = function(input, array) {
            array[callback] = toInt(input);
        };
        for (i = 0; i < token.length; i++) tokens[token[i]] = func;
    }
    function addWeekParseToken(token, callback) {
        addParseToken(token, function(input, array, config, token) {
            config._w = config._w || {}, callback(input, config._w, config, token);
        });
    }
    function addTimeToArrayFromToken(token, input, config) {
        if (null != input && hasOwnProp(tokens, token)) tokens[token](input, config._a, config, token);
    }
    var YEAR = 0;
    var MONTH = 1;
    var DATE = 2;
    var HOUR = 3;
    var MINUTE = 4;
    var SECOND = 5;
    var MILLISECOND = 6;
    var WEEK = 7;
    var WEEKDAY = 8;
    function daysInYear(year) {
        return isLeapYear(year) ? 366 : 365;
    }
    function isLeapYear(year) {
        return year % 4 === 0 && year % 100 !== 0 || year % 400 === 0;
    }
    addFormatToken("Y", 0, 0, function() {
        var y = this.year();
        return y <= 9999 ? "" + y : "+" + y;
    }), addFormatToken(0, [ "YY", 2 ], 0, function() {
        return this.year() % 100;
    }), addFormatToken(0, [ "YYYY", 4 ], 0, "year"), addFormatToken(0, [ "YYYYY", 5 ], 0, "year"), 
    addFormatToken(0, [ "YYYYYY", 6, true ], 0, "year"), addUnitAlias("year", "y"), 
    addUnitPriority("year", 1), addRegexToken("Y", matchSigned), addRegexToken("YY", match1to2, match2), 
    addRegexToken("YYYY", match1to4, match4), addRegexToken("YYYYY", match1to6, match6), 
    addRegexToken("YYYYYY", match1to6, match6), addParseToken([ "YYYYY", "YYYYYY" ], YEAR), 
    addParseToken("YYYY", function(input, array) {
        array[YEAR] = 2 === input.length ? hooks.parseTwoDigitYear(input) : toInt(input);
    }), addParseToken("YY", function(input, array) {
        array[YEAR] = hooks.parseTwoDigitYear(input);
    }), addParseToken("Y", function(input, array) {
        array[YEAR] = parseInt(input, 10);
    }), hooks.parseTwoDigitYear = function(input) {
        return toInt(input) + (toInt(input) > 68 ? 1900 : 2e3);
    };
    var getSetYear = makeGetSet("FullYear", true);
    function getIsLeapYear() {
        return isLeapYear(this.year());
    }
    function makeGetSet(unit, keepTime) {
        return function(value) {
            if (null != value) return set$1(this, unit, value), hooks.updateOffset(this, keepTime), 
            this; else return get(this, unit);
        };
    }
    function get(mom, unit) {
        return mom.isValid() ? mom._d["get" + (mom._isUTC ? "UTC" : "") + unit]() : NaN;
    }
    function set$1(mom, unit, value) {
        if (mom.isValid() && !isNaN(value)) if ("FullYear" === unit && isLeapYear(mom.year()) && 1 === mom.month() && 29 === mom.date()) mom._d["set" + (mom._isUTC ? "UTC" : "") + unit](value, mom.month(), daysInMonth(value, mom.month())); else mom._d["set" + (mom._isUTC ? "UTC" : "") + unit](value);
    }
    function stringGet(units) {
        if (units = normalizeUnits(units), isFunction(this[units])) return this[units](); else return this;
    }
    function stringSet(units, value) {
        if ("object" === typeof units) {
            units = normalizeObjectUnits(units);
            var prioritized = getPrioritizedUnits(units);
            for (var i = 0; i < prioritized.length; i++) this[prioritized[i].unit](units[prioritized[i].unit]);
        } else if (units = normalizeUnits(units), isFunction(this[units])) return this[units](value);
        return this;
    }
    function mod(n, x) {
        return (n % x + x) % x;
    }
    var indexOf;
    if (Array.prototype.indexOf) indexOf = Array.prototype.indexOf; else indexOf = function(o) {
        var i;
        for (i = 0; i < this.length; ++i) if (this[i] === o) return i;
        return -1;
    };
    function daysInMonth(year, month) {
        if (isNaN(year) || isNaN(month)) return NaN;
        var modMonth = mod(month, 12);
        return year += (month - modMonth) / 12, 1 === modMonth ? isLeapYear(year) ? 29 : 28 : 31 - modMonth % 7 % 2;
    }
    addFormatToken("M", [ "MM", 2 ], "Mo", function() {
        return this.month() + 1;
    }), addFormatToken("MMM", 0, 0, function(format) {
        return this.localeData().monthsShort(this, format);
    }), addFormatToken("MMMM", 0, 0, function(format) {
        return this.localeData().months(this, format);
    }), addUnitAlias("month", "M"), addUnitPriority("month", 8), addRegexToken("M", match1to2), 
    addRegexToken("MM", match1to2, match2), addRegexToken("MMM", function(isStrict, locale) {
        return locale.monthsShortRegex(isStrict);
    }), addRegexToken("MMMM", function(isStrict, locale) {
        return locale.monthsRegex(isStrict);
    }), addParseToken([ "M", "MM" ], function(input, array) {
        array[MONTH] = toInt(input) - 1;
    }), addParseToken([ "MMM", "MMMM" ], function(input, array, config, token) {
        var month = config._locale.monthsParse(input, token, config._strict);
        if (null != month) array[MONTH] = month; else getParsingFlags(config).invalidMonth = input;
    });
    var MONTHS_IN_FORMAT = /D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/;
    var defaultLocaleMonths = "January_February_March_April_May_June_July_August_September_October_November_December".split("_");
    function localeMonths(m, format) {
        if (!m) return isArray(this._months) ? this._months : this._months["standalone"]; else return isArray(this._months) ? this._months[m.month()] : this._months[(this._months.isFormat || MONTHS_IN_FORMAT).test(format) ? "format" : "standalone"][m.month()];
    }
    var defaultLocaleMonthsShort = "Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_");
    function localeMonthsShort(m, format) {
        if (!m) return isArray(this._monthsShort) ? this._monthsShort : this._monthsShort["standalone"]; else return isArray(this._monthsShort) ? this._monthsShort[m.month()] : this._monthsShort[MONTHS_IN_FORMAT.test(format) ? "format" : "standalone"][m.month()];
    }
    function handleStrictParse(monthName, format, strict) {
        var i, ii, mom, llc = monthName.toLocaleLowerCase();
        if (!this._monthsParse) for (this._monthsParse = [], this._longMonthsParse = [], 
        this._shortMonthsParse = [], i = 0; i < 12; ++i) mom = createUTC([ 2e3, i ]), this._shortMonthsParse[i] = this.monthsShort(mom, "").toLocaleLowerCase(), 
        this._longMonthsParse[i] = this.months(mom, "").toLocaleLowerCase();
        if (strict) if ("MMM" === format) return ii = indexOf.call(this._shortMonthsParse, llc), 
        -1 !== ii ? ii : null; else return ii = indexOf.call(this._longMonthsParse, llc), 
        -1 !== ii ? ii : null; else if ("MMM" === format) if (ii = indexOf.call(this._shortMonthsParse, llc), 
        -1 !== ii) return ii; else return ii = indexOf.call(this._longMonthsParse, llc), 
        -1 !== ii ? ii : null; else if (ii = indexOf.call(this._longMonthsParse, llc), -1 !== ii) return ii; else return ii = indexOf.call(this._shortMonthsParse, llc), 
        -1 !== ii ? ii : null;
    }
    function localeMonthsParse(monthName, format, strict) {
        var i, mom, regex;
        if (this._monthsParseExact) return handleStrictParse.call(this, monthName, format, strict);
        if (!this._monthsParse) this._monthsParse = [], this._longMonthsParse = [], this._shortMonthsParse = [];
        for (i = 0; i < 12; i++) {
            if (mom = createUTC([ 2e3, i ]), strict && !this._longMonthsParse[i]) this._longMonthsParse[i] = new RegExp("^" + this.months(mom, "").replace(".", "") + "$", "i"), 
            this._shortMonthsParse[i] = new RegExp("^" + this.monthsShort(mom, "").replace(".", "") + "$", "i");
            if (!strict && !this._monthsParse[i]) regex = "^" + this.months(mom, "") + "|^" + this.monthsShort(mom, ""), 
            this._monthsParse[i] = new RegExp(regex.replace(".", ""), "i");
            if (strict && "MMMM" === format && this._longMonthsParse[i].test(monthName)) return i; else if (strict && "MMM" === format && this._shortMonthsParse[i].test(monthName)) return i; else if (!strict && this._monthsParse[i].test(monthName)) return i;
        }
    }
    function setMonth(mom, value) {
        var dayOfMonth;
        if (!mom.isValid()) return mom;
        if ("string" === typeof value) if (/^\d+$/.test(value)) value = toInt(value); else if (value = mom.localeData().monthsParse(value), 
        !isNumber(value)) return mom;
        return dayOfMonth = Math.min(mom.date(), daysInMonth(mom.year(), value)), mom._d["set" + (mom._isUTC ? "UTC" : "") + "Month"](value, dayOfMonth), 
        mom;
    }
    function getSetMonth(value) {
        if (null != value) return setMonth(this, value), hooks.updateOffset(this, true), 
        this; else return get(this, "Month");
    }
    function getDaysInMonth() {
        return daysInMonth(this.year(), this.month());
    }
    var defaultMonthsShortRegex = matchWord;
    function monthsShortRegex(isStrict) {
        if (this._monthsParseExact) {
            if (!hasOwnProp(this, "_monthsRegex")) computeMonthsParse.call(this);
            if (isStrict) return this._monthsShortStrictRegex; else return this._monthsShortRegex;
        } else {
            if (!hasOwnProp(this, "_monthsShortRegex")) this._monthsShortRegex = defaultMonthsShortRegex;
            return this._monthsShortStrictRegex && isStrict ? this._monthsShortStrictRegex : this._monthsShortRegex;
        }
    }
    var defaultMonthsRegex = matchWord;
    function monthsRegex(isStrict) {
        if (this._monthsParseExact) {
            if (!hasOwnProp(this, "_monthsRegex")) computeMonthsParse.call(this);
            if (isStrict) return this._monthsStrictRegex; else return this._monthsRegex;
        } else {
            if (!hasOwnProp(this, "_monthsRegex")) this._monthsRegex = defaultMonthsRegex;
            return this._monthsStrictRegex && isStrict ? this._monthsStrictRegex : this._monthsRegex;
        }
    }
    function computeMonthsParse() {
        function cmpLenRev(a, b) {
            return b.length - a.length;
        }
        var i, mom, shortPieces = [], longPieces = [], mixedPieces = [];
        for (i = 0; i < 12; i++) mom = createUTC([ 2e3, i ]), shortPieces.push(this.monthsShort(mom, "")), 
        longPieces.push(this.months(mom, "")), mixedPieces.push(this.months(mom, "")), mixedPieces.push(this.monthsShort(mom, ""));
        for (shortPieces.sort(cmpLenRev), longPieces.sort(cmpLenRev), mixedPieces.sort(cmpLenRev), 
        i = 0; i < 12; i++) shortPieces[i] = regexEscape(shortPieces[i]), longPieces[i] = regexEscape(longPieces[i]);
        for (i = 0; i < 24; i++) mixedPieces[i] = regexEscape(mixedPieces[i]);
        this._monthsRegex = new RegExp("^(" + mixedPieces.join("|") + ")", "i"), this._monthsShortRegex = this._monthsRegex, 
        this._monthsStrictRegex = new RegExp("^(" + longPieces.join("|") + ")", "i"), this._monthsShortStrictRegex = new RegExp("^(" + shortPieces.join("|") + ")", "i");
    }
    function createDate(y, m, d, h, M, s, ms) {
        var date = new Date(y, m, d, h, M, s, ms);
        if (y < 100 && y >= 0 && isFinite(date.getFullYear())) date.setFullYear(y);
        return date;
    }
    function createUTCDate(y) {
        var date = new Date(Date.UTC.apply(null, arguments));
        if (y < 100 && y >= 0 && isFinite(date.getUTCFullYear())) date.setUTCFullYear(y);
        return date;
    }
    function firstWeekOffset(year, dow, doy) {
        var fwd = 7 + dow - doy, fwdlw = (7 + createUTCDate(year, 0, fwd).getUTCDay() - dow) % 7;
        return -fwdlw + fwd - 1;
    }
    function dayOfYearFromWeeks(year, week, weekday, dow, doy) {
        var resYear, resDayOfYear, localWeekday = (7 + weekday - dow) % 7, weekOffset = firstWeekOffset(year, dow, doy), dayOfYear = 1 + 7 * (week - 1) + localWeekday + weekOffset;
        if (dayOfYear <= 0) resYear = year - 1, resDayOfYear = daysInYear(resYear) + dayOfYear; else if (dayOfYear > daysInYear(year)) resYear = year + 1, 
        resDayOfYear = dayOfYear - daysInYear(year); else resYear = year, resDayOfYear = dayOfYear;
        return {
            year: resYear,
            dayOfYear: resDayOfYear
        };
    }
    function weekOfYear(mom, dow, doy) {
        var resWeek, resYear, weekOffset = firstWeekOffset(mom.year(), dow, doy), week = Math.floor((mom.dayOfYear() - weekOffset - 1) / 7) + 1;
        if (week < 1) resYear = mom.year() - 1, resWeek = week + weeksInYear(resYear, dow, doy); else if (week > weeksInYear(mom.year(), dow, doy)) resWeek = week - weeksInYear(mom.year(), dow, doy), 
        resYear = mom.year() + 1; else resYear = mom.year(), resWeek = week;
        return {
            week: resWeek,
            year: resYear
        };
    }
    function weeksInYear(year, dow, doy) {
        var weekOffset = firstWeekOffset(year, dow, doy), weekOffsetNext = firstWeekOffset(year + 1, dow, doy);
        return (daysInYear(year) - weekOffset + weekOffsetNext) / 7;
    }
    function localeWeek(mom) {
        return weekOfYear(mom, this._week.dow, this._week.doy).week;
    }
    addFormatToken("w", [ "ww", 2 ], "wo", "week"), addFormatToken("W", [ "WW", 2 ], "Wo", "isoWeek"), 
    addUnitAlias("week", "w"), addUnitAlias("isoWeek", "W"), addUnitPriority("week", 5), 
    addUnitPriority("isoWeek", 5), addRegexToken("w", match1to2), addRegexToken("ww", match1to2, match2), 
    addRegexToken("W", match1to2), addRegexToken("WW", match1to2, match2), addWeekParseToken([ "w", "ww", "W", "WW" ], function(input, week, config, token) {
        week[token.substr(0, 1)] = toInt(input);
    });
    var defaultLocaleWeek = {
        dow: 0,
        doy: 6
    };
    function localeFirstDayOfWeek() {
        return this._week.dow;
    }
    function localeFirstDayOfYear() {
        return this._week.doy;
    }
    function getSetWeek(input) {
        var week = this.localeData().week(this);
        return null == input ? week : this.add(7 * (input - week), "d");
    }
    function getSetISOWeek(input) {
        var week = weekOfYear(this, 1, 4).week;
        return null == input ? week : this.add(7 * (input - week), "d");
    }
    function parseWeekday(input, locale) {
        if ("string" !== typeof input) return input;
        if (!isNaN(input)) return parseInt(input, 10);
        if (input = locale.weekdaysParse(input), "number" === typeof input) return input; else return null;
    }
    function parseIsoWeekday(input, locale) {
        if ("string" === typeof input) return locale.weekdaysParse(input) % 7 || 7; else return isNaN(input) ? null : input;
    }
    addFormatToken("d", 0, "do", "day"), addFormatToken("dd", 0, 0, function(format) {
        return this.localeData().weekdaysMin(this, format);
    }), addFormatToken("ddd", 0, 0, function(format) {
        return this.localeData().weekdaysShort(this, format);
    }), addFormatToken("dddd", 0, 0, function(format) {
        return this.localeData().weekdays(this, format);
    }), addFormatToken("e", 0, 0, "weekday"), addFormatToken("E", 0, 0, "isoWeekday"), 
    addUnitAlias("day", "d"), addUnitAlias("weekday", "e"), addUnitAlias("isoWeekday", "E"), 
    addUnitPriority("day", 11), addUnitPriority("weekday", 11), addUnitPriority("isoWeekday", 11), 
    addRegexToken("d", match1to2), addRegexToken("e", match1to2), addRegexToken("E", match1to2), 
    addRegexToken("dd", function(isStrict, locale) {
        return locale.weekdaysMinRegex(isStrict);
    }), addRegexToken("ddd", function(isStrict, locale) {
        return locale.weekdaysShortRegex(isStrict);
    }), addRegexToken("dddd", function(isStrict, locale) {
        return locale.weekdaysRegex(isStrict);
    }), addWeekParseToken([ "dd", "ddd", "dddd" ], function(input, week, config, token) {
        var weekday = config._locale.weekdaysParse(input, token, config._strict);
        if (null != weekday) week.d = weekday; else getParsingFlags(config).invalidWeekday = input;
    }), addWeekParseToken([ "d", "e", "E" ], function(input, week, config, token) {
        week[token] = toInt(input);
    });
    var defaultLocaleWeekdays = "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_");
    function localeWeekdays(m, format) {
        if (!m) return isArray(this._weekdays) ? this._weekdays : this._weekdays["standalone"]; else return isArray(this._weekdays) ? this._weekdays[m.day()] : this._weekdays[this._weekdays.isFormat.test(format) ? "format" : "standalone"][m.day()];
    }
    var defaultLocaleWeekdaysShort = "Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_");
    function localeWeekdaysShort(m) {
        return m ? this._weekdaysShort[m.day()] : this._weekdaysShort;
    }
    var defaultLocaleWeekdaysMin = "Su_Mo_Tu_We_Th_Fr_Sa".split("_");
    function localeWeekdaysMin(m) {
        return m ? this._weekdaysMin[m.day()] : this._weekdaysMin;
    }
    function handleStrictParse$1(weekdayName, format, strict) {
        var i, ii, mom, llc = weekdayName.toLocaleLowerCase();
        if (!this._weekdaysParse) for (this._weekdaysParse = [], this._shortWeekdaysParse = [], 
        this._minWeekdaysParse = [], i = 0; i < 7; ++i) mom = createUTC([ 2e3, 1 ]).day(i), 
        this._minWeekdaysParse[i] = this.weekdaysMin(mom, "").toLocaleLowerCase(), this._shortWeekdaysParse[i] = this.weekdaysShort(mom, "").toLocaleLowerCase(), 
        this._weekdaysParse[i] = this.weekdays(mom, "").toLocaleLowerCase();
        if (strict) if ("dddd" === format) return ii = indexOf.call(this._weekdaysParse, llc), 
        -1 !== ii ? ii : null; else if ("ddd" === format) return ii = indexOf.call(this._shortWeekdaysParse, llc), 
        -1 !== ii ? ii : null; else return ii = indexOf.call(this._minWeekdaysParse, llc), 
        -1 !== ii ? ii : null; else if ("dddd" === format) {
            if (ii = indexOf.call(this._weekdaysParse, llc), -1 !== ii) return ii;
            if (ii = indexOf.call(this._shortWeekdaysParse, llc), -1 !== ii) return ii; else return ii = indexOf.call(this._minWeekdaysParse, llc), 
            -1 !== ii ? ii : null;
        } else if ("ddd" === format) {
            if (ii = indexOf.call(this._shortWeekdaysParse, llc), -1 !== ii) return ii;
            if (ii = indexOf.call(this._weekdaysParse, llc), -1 !== ii) return ii; else return ii = indexOf.call(this._minWeekdaysParse, llc), 
            -1 !== ii ? ii : null;
        } else {
            if (ii = indexOf.call(this._minWeekdaysParse, llc), -1 !== ii) return ii;
            if (ii = indexOf.call(this._weekdaysParse, llc), -1 !== ii) return ii; else return ii = indexOf.call(this._shortWeekdaysParse, llc), 
            -1 !== ii ? ii : null;
        }
    }
    function localeWeekdaysParse(weekdayName, format, strict) {
        var i, mom, regex;
        if (this._weekdaysParseExact) return handleStrictParse$1.call(this, weekdayName, format, strict);
        if (!this._weekdaysParse) this._weekdaysParse = [], this._minWeekdaysParse = [], 
        this._shortWeekdaysParse = [], this._fullWeekdaysParse = [];
        for (i = 0; i < 7; i++) {
            if (mom = createUTC([ 2e3, 1 ]).day(i), strict && !this._fullWeekdaysParse[i]) this._fullWeekdaysParse[i] = new RegExp("^" + this.weekdays(mom, "").replace(".", ".?") + "$", "i"), 
            this._shortWeekdaysParse[i] = new RegExp("^" + this.weekdaysShort(mom, "").replace(".", ".?") + "$", "i"), 
            this._minWeekdaysParse[i] = new RegExp("^" + this.weekdaysMin(mom, "").replace(".", ".?") + "$", "i");
            if (!this._weekdaysParse[i]) regex = "^" + this.weekdays(mom, "") + "|^" + this.weekdaysShort(mom, "") + "|^" + this.weekdaysMin(mom, ""), 
            this._weekdaysParse[i] = new RegExp(regex.replace(".", ""), "i");
            if (strict && "dddd" === format && this._fullWeekdaysParse[i].test(weekdayName)) return i; else if (strict && "ddd" === format && this._shortWeekdaysParse[i].test(weekdayName)) return i; else if (strict && "dd" === format && this._minWeekdaysParse[i].test(weekdayName)) return i; else if (!strict && this._weekdaysParse[i].test(weekdayName)) return i;
        }
    }
    function getSetDayOfWeek(input) {
        if (!this.isValid()) return null != input ? this : NaN;
        var day = this._isUTC ? this._d.getUTCDay() : this._d.getDay();
        if (null != input) return input = parseWeekday(input, this.localeData()), this.add(input - day, "d"); else return day;
    }
    function getSetLocaleDayOfWeek(input) {
        if (!this.isValid()) return null != input ? this : NaN;
        var weekday = (this.day() + 7 - this.localeData()._week.dow) % 7;
        return null == input ? weekday : this.add(input - weekday, "d");
    }
    function getSetISODayOfWeek(input) {
        if (!this.isValid()) return null != input ? this : NaN;
        if (null != input) {
            var weekday = parseIsoWeekday(input, this.localeData());
            return this.day(this.day() % 7 ? weekday : weekday - 7);
        } else return this.day() || 7;
    }
    var defaultWeekdaysRegex = matchWord;
    function weekdaysRegex(isStrict) {
        if (this._weekdaysParseExact) {
            if (!hasOwnProp(this, "_weekdaysRegex")) computeWeekdaysParse.call(this);
            if (isStrict) return this._weekdaysStrictRegex; else return this._weekdaysRegex;
        } else {
            if (!hasOwnProp(this, "_weekdaysRegex")) this._weekdaysRegex = defaultWeekdaysRegex;
            return this._weekdaysStrictRegex && isStrict ? this._weekdaysStrictRegex : this._weekdaysRegex;
        }
    }
    var defaultWeekdaysShortRegex = matchWord;
    function weekdaysShortRegex(isStrict) {
        if (this._weekdaysParseExact) {
            if (!hasOwnProp(this, "_weekdaysRegex")) computeWeekdaysParse.call(this);
            if (isStrict) return this._weekdaysShortStrictRegex; else return this._weekdaysShortRegex;
        } else {
            if (!hasOwnProp(this, "_weekdaysShortRegex")) this._weekdaysShortRegex = defaultWeekdaysShortRegex;
            return this._weekdaysShortStrictRegex && isStrict ? this._weekdaysShortStrictRegex : this._weekdaysShortRegex;
        }
    }
    var defaultWeekdaysMinRegex = matchWord;
    function weekdaysMinRegex(isStrict) {
        if (this._weekdaysParseExact) {
            if (!hasOwnProp(this, "_weekdaysRegex")) computeWeekdaysParse.call(this);
            if (isStrict) return this._weekdaysMinStrictRegex; else return this._weekdaysMinRegex;
        } else {
            if (!hasOwnProp(this, "_weekdaysMinRegex")) this._weekdaysMinRegex = defaultWeekdaysMinRegex;
            return this._weekdaysMinStrictRegex && isStrict ? this._weekdaysMinStrictRegex : this._weekdaysMinRegex;
        }
    }
    function computeWeekdaysParse() {
        function cmpLenRev(a, b) {
            return b.length - a.length;
        }
        var i, mom, minp, shortp, longp, minPieces = [], shortPieces = [], longPieces = [], mixedPieces = [];
        for (i = 0; i < 7; i++) mom = createUTC([ 2e3, 1 ]).day(i), minp = this.weekdaysMin(mom, ""), 
        shortp = this.weekdaysShort(mom, ""), longp = this.weekdays(mom, ""), minPieces.push(minp), 
        shortPieces.push(shortp), longPieces.push(longp), mixedPieces.push(minp), mixedPieces.push(shortp), 
        mixedPieces.push(longp);
        for (minPieces.sort(cmpLenRev), shortPieces.sort(cmpLenRev), longPieces.sort(cmpLenRev), 
        mixedPieces.sort(cmpLenRev), i = 0; i < 7; i++) shortPieces[i] = regexEscape(shortPieces[i]), 
        longPieces[i] = regexEscape(longPieces[i]), mixedPieces[i] = regexEscape(mixedPieces[i]);
        this._weekdaysRegex = new RegExp("^(" + mixedPieces.join("|") + ")", "i"), this._weekdaysShortRegex = this._weekdaysRegex, 
        this._weekdaysMinRegex = this._weekdaysRegex, this._weekdaysStrictRegex = new RegExp("^(" + longPieces.join("|") + ")", "i"), 
        this._weekdaysShortStrictRegex = new RegExp("^(" + shortPieces.join("|") + ")", "i"), 
        this._weekdaysMinStrictRegex = new RegExp("^(" + minPieces.join("|") + ")", "i");
    }
    function hFormat() {
        return this.hours() % 12 || 12;
    }
    function kFormat() {
        return this.hours() || 24;
    }
    function meridiem(token, lowercase) {
        addFormatToken(token, 0, 0, function() {
            return this.localeData().meridiem(this.hours(), this.minutes(), lowercase);
        });
    }
    function matchMeridiem(isStrict, locale) {
        return locale._meridiemParse;
    }
    function localeIsPM(input) {
        return "p" === (input + "").toLowerCase().charAt(0);
    }
    addFormatToken("H", [ "HH", 2 ], 0, "hour"), addFormatToken("h", [ "hh", 2 ], 0, hFormat), 
    addFormatToken("k", [ "kk", 2 ], 0, kFormat), addFormatToken("hmm", 0, 0, function() {
        return "" + hFormat.apply(this) + zeroFill(this.minutes(), 2);
    }), addFormatToken("hmmss", 0, 0, function() {
        return "" + hFormat.apply(this) + zeroFill(this.minutes(), 2) + zeroFill(this.seconds(), 2);
    }), addFormatToken("Hmm", 0, 0, function() {
        return "" + this.hours() + zeroFill(this.minutes(), 2);
    }), addFormatToken("Hmmss", 0, 0, function() {
        return "" + this.hours() + zeroFill(this.minutes(), 2) + zeroFill(this.seconds(), 2);
    }), meridiem("a", true), meridiem("A", false), addUnitAlias("hour", "h"), addUnitPriority("hour", 13), 
    addRegexToken("a", matchMeridiem), addRegexToken("A", matchMeridiem), addRegexToken("H", match1to2), 
    addRegexToken("h", match1to2), addRegexToken("k", match1to2), addRegexToken("HH", match1to2, match2), 
    addRegexToken("hh", match1to2, match2), addRegexToken("kk", match1to2, match2), 
    addRegexToken("hmm", match3to4), addRegexToken("hmmss", match5to6), addRegexToken("Hmm", match3to4), 
    addRegexToken("Hmmss", match5to6), addParseToken([ "H", "HH" ], HOUR), addParseToken([ "k", "kk" ], function(input, array, config) {
        var kInput = toInt(input);
        array[HOUR] = 24 === kInput ? 0 : kInput;
    }), addParseToken([ "a", "A" ], function(input, array, config) {
        config._isPm = config._locale.isPM(input), config._meridiem = input;
    }), addParseToken([ "h", "hh" ], function(input, array, config) {
        array[HOUR] = toInt(input), getParsingFlags(config).bigHour = true;
    }), addParseToken("hmm", function(input, array, config) {
        var pos = input.length - 2;
        array[HOUR] = toInt(input.substr(0, pos)), array[MINUTE] = toInt(input.substr(pos)), 
        getParsingFlags(config).bigHour = true;
    }), addParseToken("hmmss", function(input, array, config) {
        var pos1 = input.length - 4;
        var pos2 = input.length - 2;
        array[HOUR] = toInt(input.substr(0, pos1)), array[MINUTE] = toInt(input.substr(pos1, 2)), 
        array[SECOND] = toInt(input.substr(pos2)), getParsingFlags(config).bigHour = true;
    }), addParseToken("Hmm", function(input, array, config) {
        var pos = input.length - 2;
        array[HOUR] = toInt(input.substr(0, pos)), array[MINUTE] = toInt(input.substr(pos));
    }), addParseToken("Hmmss", function(input, array, config) {
        var pos1 = input.length - 4;
        var pos2 = input.length - 2;
        array[HOUR] = toInt(input.substr(0, pos1)), array[MINUTE] = toInt(input.substr(pos1, 2)), 
        array[SECOND] = toInt(input.substr(pos2));
    });
    var defaultLocaleMeridiemParse = /[ap]\.?m?\.?/i;
    function localeMeridiem(hours, minutes, isLower) {
        if (hours > 11) return isLower ? "pm" : "PM"; else return isLower ? "am" : "AM";
    }
    var getSetHour = makeGetSet("Hours", true);
    var baseConfig = {
        calendar: defaultCalendar,
        longDateFormat: defaultLongDateFormat,
        invalidDate: defaultInvalidDate,
        ordinal: defaultOrdinal,
        dayOfMonthOrdinalParse: defaultDayOfMonthOrdinalParse,
        relativeTime: defaultRelativeTime,
        months: defaultLocaleMonths,
        monthsShort: defaultLocaleMonthsShort,
        week: defaultLocaleWeek,
        weekdays: defaultLocaleWeekdays,
        weekdaysMin: defaultLocaleWeekdaysMin,
        weekdaysShort: defaultLocaleWeekdaysShort,
        meridiemParse: defaultLocaleMeridiemParse
    };
    var locales = {};
    var localeFamilies = {};
    var globalLocale;
    function normalizeLocale(key) {
        return key ? key.toLowerCase().replace("_", "-") : key;
    }
    function chooseLocale(names) {
        var j, next, locale, split, i = 0;
        for (;i < names.length; ) {
            for (split = normalizeLocale(names[i]).split("-"), j = split.length, next = normalizeLocale(names[i + 1]), 
            next = next ? next.split("-") : null; j > 0; ) {
                if (locale = loadLocale(split.slice(0, j).join("-")), locale) return locale;
                if (next && next.length >= j && compareArrays(split, next, true) >= j - 1) break;
                j--;
            }
            i++;
        }
        return globalLocale;
    }
    function loadLocale(name) {
        var oldLocale = null;
        if (!locales[name] && "undefined" !== typeof module && module && module.exports) try {
            oldLocale = globalLocale._abbr;
            var aliasedRequire = require;
            aliasedRequire("./locale/" + name), getSetGlobalLocale(oldLocale);
        } catch (e) {}
        return locales[name];
    }
    function getSetGlobalLocale(key, values) {
        var data;
        if (key) {
            if (isUndefined(values)) data = getLocale(key); else data = defineLocale(key, values);
            if (data) globalLocale = data; else if ("undefined" !== typeof console && console.warn) void 0;
        }
        return globalLocale._abbr;
    }
    function defineLocale(name, config) {
        if (null !== config) {
            var locale, parentConfig = baseConfig;
            if (config.abbr = name, null != locales[name]) deprecateSimple("defineLocaleOverride", "use moment.updateLocale(localeName, config) to change " + "an existing locale. moment.defineLocale(localeName, " + "config) should only be used for creating a new locale " + "See http://momentjs.com/guides/#/warnings/define-locale/ for more info."), 
            parentConfig = locales[name]._config; else if (null != config.parentLocale) if (null != locales[config.parentLocale]) parentConfig = locales[config.parentLocale]._config; else if (locale = loadLocale(config.parentLocale), 
            null != locale) parentConfig = locale._config; else {
                if (!localeFamilies[config.parentLocale]) localeFamilies[config.parentLocale] = [];
                return localeFamilies[config.parentLocale].push({
                    name: name,
                    config: config
                }), null;
            }
            if (locales[name] = new Locale(mergeConfigs(parentConfig, config)), localeFamilies[name]) localeFamilies[name].forEach(function(x) {
                defineLocale(x.name, x.config);
            });
            return getSetGlobalLocale(name), locales[name];
        } else return delete locales[name], null;
    }
    function updateLocale(name, config) {
        if (null != config) {
            var locale, tmpLocale, parentConfig = baseConfig;
            if (tmpLocale = loadLocale(name), null != tmpLocale) parentConfig = tmpLocale._config;
            config = mergeConfigs(parentConfig, config), locale = new Locale(config), locale.parentLocale = locales[name], 
            locales[name] = locale, getSetGlobalLocale(name);
        } else if (null != locales[name]) if (null != locales[name].parentLocale) locales[name] = locales[name].parentLocale; else if (null != locales[name]) delete locales[name];
        return locales[name];
    }
    function getLocale(key) {
        var locale;
        if (key && key._locale && key._locale._abbr) key = key._locale._abbr;
        if (!key) return globalLocale;
        if (!isArray(key)) {
            if (locale = loadLocale(key), locale) return locale;
            key = [ key ];
        }
        return chooseLocale(key);
    }
    function listLocales() {
        return keys(locales);
    }
    function checkOverflow(m) {
        var overflow;
        var a = m._a;
        if (a && -2 === getParsingFlags(m).overflow) {
            if (overflow = a[MONTH] < 0 || a[MONTH] > 11 ? MONTH : a[DATE] < 1 || a[DATE] > daysInMonth(a[YEAR], a[MONTH]) ? DATE : a[HOUR] < 0 || a[HOUR] > 24 || 24 === a[HOUR] && (0 !== a[MINUTE] || 0 !== a[SECOND] || 0 !== a[MILLISECOND]) ? HOUR : a[MINUTE] < 0 || a[MINUTE] > 59 ? MINUTE : a[SECOND] < 0 || a[SECOND] > 59 ? SECOND : a[MILLISECOND] < 0 || a[MILLISECOND] > 999 ? MILLISECOND : -1, 
            getParsingFlags(m)._overflowDayOfYear && (overflow < YEAR || overflow > DATE)) overflow = DATE;
            if (getParsingFlags(m)._overflowWeeks && -1 === overflow) overflow = WEEK;
            if (getParsingFlags(m)._overflowWeekday && -1 === overflow) overflow = WEEKDAY;
            getParsingFlags(m).overflow = overflow;
        }
        return m;
    }
    function defaults(a, b, c) {
        if (null != a) return a;
        if (null != b) return b; else return c;
    }
    function currentDateArray(config) {
        var nowValue = new Date(hooks.now());
        if (config._useUTC) return [ nowValue.getUTCFullYear(), nowValue.getUTCMonth(), nowValue.getUTCDate() ]; else return [ nowValue.getFullYear(), nowValue.getMonth(), nowValue.getDate() ];
    }
    function configFromArray(config) {
        var i, date, currentDate, expectedWeekday, yearToUse, input = [];
        if (!config._d) {
            if (currentDate = currentDateArray(config), config._w && null == config._a[DATE] && null == config._a[MONTH]) dayOfYearFromWeekInfo(config);
            if (null != config._dayOfYear) {
                if (yearToUse = defaults(config._a[YEAR], currentDate[YEAR]), config._dayOfYear > daysInYear(yearToUse) || 0 === config._dayOfYear) getParsingFlags(config)._overflowDayOfYear = true;
                date = createUTCDate(yearToUse, 0, config._dayOfYear), config._a[MONTH] = date.getUTCMonth(), 
                config._a[DATE] = date.getUTCDate();
            }
            for (i = 0; i < 3 && null == config._a[i]; ++i) config._a[i] = input[i] = currentDate[i];
            for (;i < 7; i++) config._a[i] = input[i] = null == config._a[i] ? 2 === i ? 1 : 0 : config._a[i];
            if (24 === config._a[HOUR] && 0 === config._a[MINUTE] && 0 === config._a[SECOND] && 0 === config._a[MILLISECOND]) config._nextDay = true, 
            config._a[HOUR] = 0;
            if (config._d = (config._useUTC ? createUTCDate : createDate).apply(null, input), 
            expectedWeekday = config._useUTC ? config._d.getUTCDay() : config._d.getDay(), null != config._tzm) config._d.setUTCMinutes(config._d.getUTCMinutes() - config._tzm);
            if (config._nextDay) config._a[HOUR] = 24;
            if (config._w && "undefined" !== typeof config._w.d && config._w.d !== expectedWeekday) getParsingFlags(config).weekdayMismatch = true;
        }
    }
    function dayOfYearFromWeekInfo(config) {
        var w, weekYear, week, weekday, dow, doy, temp, weekdayOverflow;
        if (w = config._w, null != w.GG || null != w.W || null != w.E) {
            if (dow = 1, doy = 4, weekYear = defaults(w.GG, config._a[YEAR], weekOfYear(createLocal(), 1, 4).year), 
            week = defaults(w.W, 1), weekday = defaults(w.E, 1), weekday < 1 || weekday > 7) weekdayOverflow = true;
        } else {
            dow = config._locale._week.dow, doy = config._locale._week.doy;
            var curWeek = weekOfYear(createLocal(), dow, doy);
            if (weekYear = defaults(w.gg, config._a[YEAR], curWeek.year), week = defaults(w.w, curWeek.week), 
            null != w.d) {
                if (weekday = w.d, weekday < 0 || weekday > 6) weekdayOverflow = true;
            } else if (null != w.e) {
                if (weekday = w.e + dow, w.e < 0 || w.e > 6) weekdayOverflow = true;
            } else weekday = dow;
        }
        if (week < 1 || week > weeksInYear(weekYear, dow, doy)) getParsingFlags(config)._overflowWeeks = true; else if (null != weekdayOverflow) getParsingFlags(config)._overflowWeekday = true; else temp = dayOfYearFromWeeks(weekYear, week, weekday, dow, doy), 
        config._a[YEAR] = temp.year, config._dayOfYear = temp.dayOfYear;
    }
    var extendedIsoRegex = /^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/;
    var basicIsoRegex = /^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/;
    var tzRegex = /Z|[+-]\d\d(?::?\d\d)?/;
    var isoDates = [ [ "YYYYYY-MM-DD", /[+-]\d{6}-\d\d-\d\d/ ], [ "YYYY-MM-DD", /\d{4}-\d\d-\d\d/ ], [ "GGGG-[W]WW-E", /\d{4}-W\d\d-\d/ ], [ "GGGG-[W]WW", /\d{4}-W\d\d/, false ], [ "YYYY-DDD", /\d{4}-\d{3}/ ], [ "YYYY-MM", /\d{4}-\d\d/, false ], [ "YYYYYYMMDD", /[+-]\d{10}/ ], [ "YYYYMMDD", /\d{8}/ ], [ "GGGG[W]WWE", /\d{4}W\d{3}/ ], [ "GGGG[W]WW", /\d{4}W\d{2}/, false ], [ "YYYYDDD", /\d{7}/ ] ];
    var isoTimes = [ [ "HH:mm:ss.SSSS", /\d\d:\d\d:\d\d\.\d+/ ], [ "HH:mm:ss,SSSS", /\d\d:\d\d:\d\d,\d+/ ], [ "HH:mm:ss", /\d\d:\d\d:\d\d/ ], [ "HH:mm", /\d\d:\d\d/ ], [ "HHmmss.SSSS", /\d\d\d\d\d\d\.\d+/ ], [ "HHmmss,SSSS", /\d\d\d\d\d\d,\d+/ ], [ "HHmmss", /\d\d\d\d\d\d/ ], [ "HHmm", /\d\d\d\d/ ], [ "HH", /\d\d/ ] ];
    var aspNetJsonRegex = /^\/?Date\((\-?\d+)/i;
    function configFromISO(config) {
        var i, l, allowTime, dateFormat, timeFormat, tzFormat, string = config._i, match = extendedIsoRegex.exec(string) || basicIsoRegex.exec(string);
        if (match) {
            for (getParsingFlags(config).iso = true, i = 0, l = isoDates.length; i < l; i++) if (isoDates[i][1].exec(match[1])) {
                dateFormat = isoDates[i][0], allowTime = false !== isoDates[i][2];
                break;
            }
            if (null == dateFormat) return config._isValid = false, void 0;
            if (match[3]) {
                for (i = 0, l = isoTimes.length; i < l; i++) if (isoTimes[i][1].exec(match[3])) {
                    timeFormat = (match[2] || " ") + isoTimes[i][0];
                    break;
                }
                if (null == timeFormat) return config._isValid = false, void 0;
            }
            if (!allowTime && null != timeFormat) return config._isValid = false, void 0;
            if (match[4]) if (tzRegex.exec(match[4])) tzFormat = "Z"; else return config._isValid = false, 
            void 0;
            config._f = dateFormat + (timeFormat || "") + (tzFormat || ""), configFromStringAndFormat(config);
        } else config._isValid = false;
    }
    var rfc2822 = /^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/;
    function extractFromRFC2822Strings(yearStr, monthStr, dayStr, hourStr, minuteStr, secondStr) {
        var result = [ untruncateYear(yearStr), defaultLocaleMonthsShort.indexOf(monthStr), parseInt(dayStr, 10), parseInt(hourStr, 10), parseInt(minuteStr, 10) ];
        if (secondStr) result.push(parseInt(secondStr, 10));
        return result;
    }
    function untruncateYear(yearStr) {
        var year = parseInt(yearStr, 10);
        if (year <= 49) return 2e3 + year; else if (year <= 999) return 1900 + year;
        return year;
    }
    function preprocessRFC2822(s) {
        return s.replace(/\([^)]*\)|[\n\t]/g, " ").replace(/(\s\s+)/g, " ").trim();
    }
    function checkWeekday(weekdayStr, parsedInput, config) {
        if (weekdayStr) {
            var weekdayProvided = defaultLocaleWeekdaysShort.indexOf(weekdayStr), weekdayActual = new Date(parsedInput[0], parsedInput[1], parsedInput[2]).getDay();
            if (weekdayProvided !== weekdayActual) return getParsingFlags(config).weekdayMismatch = true, 
            config._isValid = false, false;
        }
        return true;
    }
    var obsOffsets = {
        UT: 0,
        GMT: 0,
        EDT: -4 * 60,
        EST: -5 * 60,
        CDT: -5 * 60,
        CST: -6 * 60,
        MDT: -6 * 60,
        MST: -7 * 60,
        PDT: -7 * 60,
        PST: -8 * 60
    };
    function calculateOffset(obsOffset, militaryOffset, numOffset) {
        if (obsOffset) return obsOffsets[obsOffset]; else if (militaryOffset) return 0; else {
            var hm = parseInt(numOffset, 10);
            var m = hm % 100, h = (hm - m) / 100;
            return 60 * h + m;
        }
    }
    function configFromRFC2822(config) {
        var match = rfc2822.exec(preprocessRFC2822(config._i));
        if (match) {
            var parsedArray = extractFromRFC2822Strings(match[4], match[3], match[2], match[5], match[6], match[7]);
            if (!checkWeekday(match[1], parsedArray, config)) return;
            config._a = parsedArray, config._tzm = calculateOffset(match[8], match[9], match[10]), 
            config._d = createUTCDate.apply(null, config._a), config._d.setUTCMinutes(config._d.getUTCMinutes() - config._tzm), 
            getParsingFlags(config).rfc2822 = true;
        } else config._isValid = false;
    }
    function configFromString(config) {
        var matched = aspNetJsonRegex.exec(config._i);
        if (null !== matched) return config._d = new Date(+matched[1]), void 0;
        if (configFromISO(config), false === config._isValid) if (delete config._isValid, 
        configFromRFC2822(config), false === config._isValid) delete config._isValid, hooks.createFromInputFallback(config);
    }
    function configFromStringAndFormat(config) {
        if (config._f === hooks.ISO_8601) return configFromISO(config), void 0;
        if (config._f === hooks.RFC_2822) return configFromRFC2822(config), void 0;
        config._a = [], getParsingFlags(config).empty = true;
        var i, parsedInput, tokens, token, skipped, string = "" + config._i, stringLength = string.length, totalParsedInputLength = 0;
        for (tokens = expandFormat(config._f, config._locale).match(formattingTokens) || [], 
        i = 0; i < tokens.length; i++) {
            if (token = tokens[i], parsedInput = (string.match(getParseRegexForToken(token, config)) || [])[0], 
            parsedInput) {
                if (skipped = string.substr(0, string.indexOf(parsedInput)), skipped.length > 0) getParsingFlags(config).unusedInput.push(skipped);
                string = string.slice(string.indexOf(parsedInput) + parsedInput.length), totalParsedInputLength += parsedInput.length;
            }
            if (formatTokenFunctions[token]) {
                if (parsedInput) getParsingFlags(config).empty = false; else getParsingFlags(config).unusedTokens.push(token);
                addTimeToArrayFromToken(token, parsedInput, config);
            } else if (config._strict && !parsedInput) getParsingFlags(config).unusedTokens.push(token);
        }
        if (getParsingFlags(config).charsLeftOver = stringLength - totalParsedInputLength, 
        string.length > 0) getParsingFlags(config).unusedInput.push(string);
        if (config._a[HOUR] <= 12 && true === getParsingFlags(config).bigHour && config._a[HOUR] > 0) getParsingFlags(config).bigHour = void 0;
        getParsingFlags(config).parsedDateParts = config._a.slice(0), getParsingFlags(config).meridiem = config._meridiem, 
        config._a[HOUR] = meridiemFixWrap(config._locale, config._a[HOUR], config._meridiem), 
        configFromArray(config), checkOverflow(config);
    }
    function meridiemFixWrap(locale, hour, meridiem) {
        var isPm;
        if (null == meridiem) return hour;
        if (null != locale.meridiemHour) return locale.meridiemHour(hour, meridiem); else if (null != locale.isPM) {
            if (isPm = locale.isPM(meridiem), isPm && hour < 12) hour += 12;
            if (!isPm && 12 === hour) hour = 0;
            return hour;
        } else return hour;
    }
    function configFromStringAndArray(config) {
        var tempConfig, bestMoment, scoreToBeat, i, currentScore;
        if (0 === config._f.length) return getParsingFlags(config).invalidFormat = true, 
        config._d = new Date(NaN), void 0;
        for (i = 0; i < config._f.length; i++) {
            if (currentScore = 0, tempConfig = copyConfig({}, config), null != config._useUTC) tempConfig._useUTC = config._useUTC;
            if (tempConfig._f = config._f[i], configFromStringAndFormat(tempConfig), isValid(tempConfig)) if (currentScore += getParsingFlags(tempConfig).charsLeftOver, 
            currentScore += 10 * getParsingFlags(tempConfig).unusedTokens.length, getParsingFlags(tempConfig).score = currentScore, 
            null == scoreToBeat || currentScore < scoreToBeat) scoreToBeat = currentScore, bestMoment = tempConfig;
        }
        extend(config, bestMoment || tempConfig);
    }
    function configFromObject(config) {
        if (!config._d) {
            var i = normalizeObjectUnits(config._i);
            config._a = map([ i.year, i.month, i.day || i.date, i.hour, i.minute, i.second, i.millisecond ], function(obj) {
                return obj && parseInt(obj, 10);
            }), configFromArray(config);
        }
    }
    function createFromConfig(config) {
        var res = new Moment(checkOverflow(prepareConfig(config)));
        if (res._nextDay) res.add(1, "d"), res._nextDay = void 0;
        return res;
    }
    function prepareConfig(config) {
        var input = config._i, format = config._f;
        if (config._locale = config._locale || getLocale(config._l), null === input || void 0 === format && "" === input) return createInvalid({
            nullInput: true
        });
        if ("string" === typeof input) config._i = input = config._locale.preparse(input);
        if (isMoment(input)) return new Moment(checkOverflow(input)); else if (isDate(input)) config._d = input; else if (isArray(format)) configFromStringAndArray(config); else if (format) configFromStringAndFormat(config); else configFromInput(config);
        if (!isValid(config)) config._d = null;
        return config;
    }
    function configFromInput(config) {
        var input = config._i;
        if (isUndefined(input)) config._d = new Date(hooks.now()); else if (isDate(input)) config._d = new Date(input.valueOf()); else if ("string" === typeof input) configFromString(config); else if (isArray(input)) config._a = map(input.slice(0), function(obj) {
            return parseInt(obj, 10);
        }), configFromArray(config); else if (isObject(input)) configFromObject(config); else if (isNumber(input)) config._d = new Date(input); else hooks.createFromInputFallback(config);
    }
    function createLocalOrUTC(input, format, locale, strict, isUTC) {
        var c = {};
        if (true === locale || false === locale) strict = locale, locale = void 0;
        if (isObject(input) && isObjectEmpty(input) || isArray(input) && 0 === input.length) input = void 0;
        return c._isAMomentObject = true, c._useUTC = c._isUTC = isUTC, c._l = locale, c._i = input, 
        c._f = format, c._strict = strict, createFromConfig(c);
    }
    function createLocal(input, format, locale, strict) {
        return createLocalOrUTC(input, format, locale, strict, false);
    }
    hooks.createFromInputFallback = deprecate("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), " + "which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are " + "discouraged and will be removed in an upcoming major release. Please refer to " + "http://momentjs.com/guides/#/warnings/js-date/ for more info.", function(config) {
        config._d = new Date(config._i + (config._useUTC ? " UTC" : ""));
    }), hooks.ISO_8601 = function() {}, hooks.RFC_2822 = function() {};
    var prototypeMin = deprecate("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/", function() {
        var other = createLocal.apply(null, arguments);
        if (this.isValid() && other.isValid()) return other < this ? this : other; else return createInvalid();
    });
    var prototypeMax = deprecate("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/", function() {
        var other = createLocal.apply(null, arguments);
        if (this.isValid() && other.isValid()) return other > this ? this : other; else return createInvalid();
    });
    function pickBy(fn, moments) {
        var res, i;
        if (1 === moments.length && isArray(moments[0])) moments = moments[0];
        if (!moments.length) return createLocal();
        for (res = moments[0], i = 1; i < moments.length; ++i) if (!moments[i].isValid() || moments[i][fn](res)) res = moments[i];
        return res;
    }
    function min() {
        var args = [].slice.call(arguments, 0);
        return pickBy("isBefore", args);
    }
    function max() {
        var args = [].slice.call(arguments, 0);
        return pickBy("isAfter", args);
    }
    var now = function() {
        return Date.now ? Date.now() : +new Date();
    };
    var ordering = [ "year", "quarter", "month", "week", "day", "hour", "minute", "second", "millisecond" ];
    function isDurationValid(m) {
        for (var key in m) if (!(-1 !== indexOf.call(ordering, key) && (null == m[key] || !isNaN(m[key])))) return false;
        var unitHasDecimal = false;
        for (var i = 0; i < ordering.length; ++i) if (m[ordering[i]]) {
            if (unitHasDecimal) return false;
            if (parseFloat(m[ordering[i]]) !== toInt(m[ordering[i]])) unitHasDecimal = true;
        }
        return true;
    }
    function isValid$1() {
        return this._isValid;
    }
    function createInvalid$1() {
        return createDuration(NaN);
    }
    function Duration(duration) {
        var normalizedInput = normalizeObjectUnits(duration), years = normalizedInput.year || 0, quarters = normalizedInput.quarter || 0, months = normalizedInput.month || 0, weeks = normalizedInput.week || 0, days = normalizedInput.day || 0, hours = normalizedInput.hour || 0, minutes = normalizedInput.minute || 0, seconds = normalizedInput.second || 0, milliseconds = normalizedInput.millisecond || 0;
        this._isValid = isDurationValid(normalizedInput), this._milliseconds = +milliseconds + 1e3 * seconds + 6e4 * minutes + 1e3 * hours * 60 * 60, 
        this._days = +days + 7 * weeks, this._months = +months + 3 * quarters + 12 * years, 
        this._data = {}, this._locale = getLocale(), this._bubble();
    }
    function isDuration(obj) {
        return obj instanceof Duration;
    }
    function absRound(number) {
        if (number < 0) return -1 * Math.round(-1 * number); else return Math.round(number);
    }
    function offset(token, separator) {
        addFormatToken(token, 0, 0, function() {
            var offset = this.utcOffset();
            var sign = "+";
            if (offset < 0) offset = -offset, sign = "-";
            return sign + zeroFill(~~(offset / 60), 2) + separator + zeroFill(~~offset % 60, 2);
        });
    }
    offset("Z", ":"), offset("ZZ", ""), addRegexToken("Z", matchShortOffset), addRegexToken("ZZ", matchShortOffset), 
    addParseToken([ "Z", "ZZ" ], function(input, array, config) {
        config._useUTC = true, config._tzm = offsetFromString(matchShortOffset, input);
    });
    var chunkOffset = /([\+\-]|\d\d)/gi;
    function offsetFromString(matcher, string) {
        var matches = (string || "").match(matcher);
        if (null === matches) return null;
        var chunk = matches[matches.length - 1] || [];
        var parts = (chunk + "").match(chunkOffset) || [ "-", 0, 0 ];
        var minutes = +60 * parts[1] + toInt(parts[2]);
        return 0 === minutes ? 0 : "+" === parts[0] ? minutes : -minutes;
    }
    function cloneWithOffset(input, model) {
        var res, diff;
        if (model._isUTC) return res = model.clone(), diff = (isMoment(input) || isDate(input) ? input.valueOf() : createLocal(input).valueOf()) - res.valueOf(), 
        res._d.setTime(res._d.valueOf() + diff), hooks.updateOffset(res, false), res; else return createLocal(input).local();
    }
    function getDateOffset(m) {
        return 15 * -Math.round(m._d.getTimezoneOffset() / 15);
    }
    function getSetOffset(input, keepLocalTime, keepMinutes) {
        var localAdjust, offset = this._offset || 0;
        if (!this.isValid()) return null != input ? this : NaN;
        if (null != input) {
            if ("string" === typeof input) {
                if (input = offsetFromString(matchShortOffset, input), null === input) return this;
            } else if (Math.abs(input) < 16 && !keepMinutes) input *= 60;
            if (!this._isUTC && keepLocalTime) localAdjust = getDateOffset(this);
            if (this._offset = input, this._isUTC = true, null != localAdjust) this.add(localAdjust, "m");
            if (offset !== input) if (!keepLocalTime || this._changeInProgress) addSubtract(this, createDuration(input - offset, "m"), 1, false); else if (!this._changeInProgress) this._changeInProgress = true, 
            hooks.updateOffset(this, true), this._changeInProgress = null;
            return this;
        } else return this._isUTC ? offset : getDateOffset(this);
    }
    function getSetZone(input, keepLocalTime) {
        if (null != input) {
            if ("string" !== typeof input) input = -input;
            return this.utcOffset(input, keepLocalTime), this;
        } else return -this.utcOffset();
    }
    function setOffsetToUTC(keepLocalTime) {
        return this.utcOffset(0, keepLocalTime);
    }
    function setOffsetToLocal(keepLocalTime) {
        if (this._isUTC) if (this.utcOffset(0, keepLocalTime), this._isUTC = false, keepLocalTime) this.subtract(getDateOffset(this), "m");
        return this;
    }
    function setOffsetToParsedOffset() {
        if (null != this._tzm) this.utcOffset(this._tzm, false, true); else if ("string" === typeof this._i) {
            var tZone = offsetFromString(matchOffset, this._i);
            if (null != tZone) this.utcOffset(tZone); else this.utcOffset(0, true);
        }
        return this;
    }
    function hasAlignedHourOffset(input) {
        if (!this.isValid()) return false; else return input = input ? createLocal(input).utcOffset() : 0, 
        (this.utcOffset() - input) % 60 === 0;
    }
    function isDaylightSavingTime() {
        return this.utcOffset() > this.clone().month(0).utcOffset() || this.utcOffset() > this.clone().month(5).utcOffset();
    }
    function isDaylightSavingTimeShifted() {
        if (!isUndefined(this._isDSTShifted)) return this._isDSTShifted;
        var c = {};
        if (copyConfig(c, this), c = prepareConfig(c), c._a) {
            var other = c._isUTC ? createUTC(c._a) : createLocal(c._a);
            this._isDSTShifted = this.isValid() && compareArrays(c._a, other.toArray()) > 0;
        } else this._isDSTShifted = false;
        return this._isDSTShifted;
    }
    function isLocal() {
        return this.isValid() ? !this._isUTC : false;
    }
    function isUtcOffset() {
        return this.isValid() ? this._isUTC : false;
    }
    function isUtc() {
        return this.isValid() ? this._isUTC && 0 === this._offset : false;
    }
    hooks.updateOffset = function() {};
    var aspNetRegex = /^(\-|\+)?(?:(\d*)[. ])?(\d+)\:(\d+)(?:\:(\d+)(\.\d*)?)?$/;
    var isoRegex = /^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;
    function createDuration(input, key) {
        var sign, ret, diffRes, duration = input, match = null;
        if (isDuration(input)) duration = {
            ms: input._milliseconds,
            d: input._days,
            M: input._months
        }; else if (isNumber(input)) if (duration = {}, key) duration[key] = input; else duration.milliseconds = input; else if (!!(match = aspNetRegex.exec(input))) sign = "-" === match[1] ? -1 : 1, 
        duration = {
            y: 0,
            d: toInt(match[DATE]) * sign,
            h: toInt(match[HOUR]) * sign,
            m: toInt(match[MINUTE]) * sign,
            s: toInt(match[SECOND]) * sign,
            ms: toInt(absRound(1e3 * match[MILLISECOND])) * sign
        }; else if (!!(match = isoRegex.exec(input))) sign = "-" === match[1] ? -1 : "+" === match[1] ? 1 : 1, 
        duration = {
            y: parseIso(match[2], sign),
            M: parseIso(match[3], sign),
            w: parseIso(match[4], sign),
            d: parseIso(match[5], sign),
            h: parseIso(match[6], sign),
            m: parseIso(match[7], sign),
            s: parseIso(match[8], sign)
        }; else if (null == duration) duration = {}; else if ("object" === typeof duration && ("from" in duration || "to" in duration)) diffRes = momentsDifference(createLocal(duration.from), createLocal(duration.to)), 
        duration = {}, duration.ms = diffRes.milliseconds, duration.M = diffRes.months;
        if (ret = new Duration(duration), isDuration(input) && hasOwnProp(input, "_locale")) ret._locale = input._locale;
        return ret;
    }
    function parseIso(inp, sign) {
        var res = inp && parseFloat(inp.replace(",", "."));
        return (isNaN(res) ? 0 : res) * sign;
    }
    function positiveMomentsDifference(base, other) {
        var res = {
            milliseconds: 0,
            months: 0
        };
        if (res.months = other.month() - base.month() + 12 * (other.year() - base.year()), 
        base.clone().add(res.months, "M").isAfter(other)) --res.months;
        return res.milliseconds = +other - +base.clone().add(res.months, "M"), res;
    }
    function momentsDifference(base, other) {
        var res;
        if (!(base.isValid() && other.isValid())) return {
            milliseconds: 0,
            months: 0
        };
        if (other = cloneWithOffset(other, base), base.isBefore(other)) res = positiveMomentsDifference(base, other); else res = positiveMomentsDifference(other, base), 
        res.milliseconds = -res.milliseconds, res.months = -res.months;
        return res;
    }
    function createAdder(direction, name) {
        return function(val, period) {
            var dur, tmp;
            if (null !== period && !isNaN(+period)) deprecateSimple(name, "moment()." + name + "(period, number) is deprecated. Please use moment()." + name + "(number, period). " + "See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."), 
            tmp = val, val = period, period = tmp;
            return val = "string" === typeof val ? +val : val, dur = createDuration(val, period), 
            addSubtract(this, dur, direction), this;
        };
    }
    function addSubtract(mom, duration, isAdding, updateOffset) {
        var milliseconds = duration._milliseconds, days = absRound(duration._days), months = absRound(duration._months);
        if (mom.isValid()) {
            if (updateOffset = null == updateOffset ? true : updateOffset, months) setMonth(mom, get(mom, "Month") + months * isAdding);
            if (days) set$1(mom, "Date", get(mom, "Date") + days * isAdding);
            if (milliseconds) mom._d.setTime(mom._d.valueOf() + milliseconds * isAdding);
            if (updateOffset) hooks.updateOffset(mom, days || months);
        }
    }
    createDuration.fn = Duration.prototype, createDuration.invalid = createInvalid$1;
    var add = createAdder(1, "add");
    var subtract = createAdder(-1, "subtract");
    function getCalendarFormat(myMoment, now) {
        var diff = myMoment.diff(now, "days", true);
        return diff < -6 ? "sameElse" : diff < -1 ? "lastWeek" : diff < 0 ? "lastDay" : diff < 1 ? "sameDay" : diff < 2 ? "nextDay" : diff < 7 ? "nextWeek" : "sameElse";
    }
    function calendar$1(time, formats) {
        var now = time || createLocal(), sod = cloneWithOffset(now, this).startOf("day"), format = hooks.calendarFormat(this, sod) || "sameElse";
        var output = formats && (isFunction(formats[format]) ? formats[format].call(this, now) : formats[format]);
        return this.format(output || this.localeData().calendar(format, this, createLocal(now)));
    }
    function clone() {
        return new Moment(this);
    }
    function isAfter(input, units) {
        var localInput = isMoment(input) ? input : createLocal(input);
        if (!(this.isValid() && localInput.isValid())) return false;
        if (units = normalizeUnits(!isUndefined(units) ? units : "millisecond"), "millisecond" === units) return this.valueOf() > localInput.valueOf(); else return localInput.valueOf() < this.clone().startOf(units).valueOf();
    }
    function isBefore(input, units) {
        var localInput = isMoment(input) ? input : createLocal(input);
        if (!(this.isValid() && localInput.isValid())) return false;
        if (units = normalizeUnits(!isUndefined(units) ? units : "millisecond"), "millisecond" === units) return this.valueOf() < localInput.valueOf(); else return this.clone().endOf(units).valueOf() < localInput.valueOf();
    }
    function isBetween(from, to, units, inclusivity) {
        return inclusivity = inclusivity || "()", ("(" === inclusivity[0] ? this.isAfter(from, units) : !this.isBefore(from, units)) && (")" === inclusivity[1] ? this.isBefore(to, units) : !this.isAfter(to, units));
    }
    function isSame(input, units) {
        var inputMs, localInput = isMoment(input) ? input : createLocal(input);
        if (!(this.isValid() && localInput.isValid())) return false;
        if (units = normalizeUnits(units || "millisecond"), "millisecond" === units) return this.valueOf() === localInput.valueOf(); else return inputMs = localInput.valueOf(), 
        this.clone().startOf(units).valueOf() <= inputMs && inputMs <= this.clone().endOf(units).valueOf();
    }
    function isSameOrAfter(input, units) {
        return this.isSame(input, units) || this.isAfter(input, units);
    }
    function isSameOrBefore(input, units) {
        return this.isSame(input, units) || this.isBefore(input, units);
    }
    function diff(input, units, asFloat) {
        var that, zoneDelta, output;
        if (!this.isValid()) return NaN;
        if (that = cloneWithOffset(input, this), !that.isValid()) return NaN;
        switch (zoneDelta = 6e4 * (that.utcOffset() - this.utcOffset()), units = normalizeUnits(units), 
        units) {
          case "year":
            output = monthDiff(this, that) / 12;
            break;

          case "month":
            output = monthDiff(this, that);
            break;

          case "quarter":
            output = monthDiff(this, that) / 3;
            break;

          case "second":
            output = (this - that) / 1e3;
            break;

          case "minute":
            output = (this - that) / 6e4;
            break;

          case "hour":
            output = (this - that) / 36e5;
            break;

          case "day":
            output = (this - that - zoneDelta) / 864e5;
            break;

          case "week":
            output = (this - that - zoneDelta) / 6048e5;
            break;

          default:
            output = this - that;
        }
        return asFloat ? output : absFloor(output);
    }
    function monthDiff(a, b) {
        var anchor2, adjust, wholeMonthDiff = 12 * (b.year() - a.year()) + (b.month() - a.month()), anchor = a.clone().add(wholeMonthDiff, "months");
        if (b - anchor < 0) anchor2 = a.clone().add(wholeMonthDiff - 1, "months"), adjust = (b - anchor) / (anchor - anchor2); else anchor2 = a.clone().add(wholeMonthDiff + 1, "months"), 
        adjust = (b - anchor) / (anchor2 - anchor);
        return -(wholeMonthDiff + adjust) || 0;
    }
    function toString() {
        return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ");
    }
    function toISOString(keepOffset) {
        if (!this.isValid()) return null;
        var utc = true !== keepOffset;
        var m = utc ? this.clone().utc() : this;
        if (m.year() < 0 || m.year() > 9999) return formatMoment(m, utc ? "YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]" : "YYYYYY-MM-DD[T]HH:mm:ss.SSSZ");
        if (isFunction(Date.prototype.toISOString)) if (utc) return this.toDate().toISOString(); else return new Date(this.valueOf() + 60 * this.utcOffset() * 1e3).toISOString().replace("Z", formatMoment(m, "Z"));
        return formatMoment(m, utc ? "YYYY-MM-DD[T]HH:mm:ss.SSS[Z]" : "YYYY-MM-DD[T]HH:mm:ss.SSSZ");
    }
    function inspect() {
        if (!this.isValid()) return "moment.invalid(/* " + this._i + " */)";
        var func = "moment";
        var zone = "";
        if (!this.isLocal()) func = 0 === this.utcOffset() ? "moment.utc" : "moment.parseZone", 
        zone = "Z";
        var prefix = "[" + func + '("]';
        var year = 0 <= this.year() && this.year() <= 9999 ? "YYYY" : "YYYYYY";
        var datetime = "-MM-DD[T]HH:mm:ss.SSS";
        var suffix = zone + '[")]';
        return this.format(prefix + year + datetime + suffix);
    }
    function format(inputString) {
        if (!inputString) inputString = this.isUtc() ? hooks.defaultFormatUtc : hooks.defaultFormat;
        var output = formatMoment(this, inputString);
        return this.localeData().postformat(output);
    }
    function from(time, withoutSuffix) {
        if (this.isValid() && (isMoment(time) && time.isValid() || createLocal(time).isValid())) return createDuration({
            to: this,
            from: time
        }).locale(this.locale()).humanize(!withoutSuffix); else return this.localeData().invalidDate();
    }
    function fromNow(withoutSuffix) {
        return this.from(createLocal(), withoutSuffix);
    }
    function to(time, withoutSuffix) {
        if (this.isValid() && (isMoment(time) && time.isValid() || createLocal(time).isValid())) return createDuration({
            from: this,
            to: time
        }).locale(this.locale()).humanize(!withoutSuffix); else return this.localeData().invalidDate();
    }
    function toNow(withoutSuffix) {
        return this.to(createLocal(), withoutSuffix);
    }
    function locale(key) {
        var newLocaleData;
        if (void 0 === key) return this._locale._abbr; else {
            if (newLocaleData = getLocale(key), null != newLocaleData) this._locale = newLocaleData;
            return this;
        }
    }
    hooks.defaultFormat = "YYYY-MM-DDTHH:mm:ssZ", hooks.defaultFormatUtc = "YYYY-MM-DDTHH:mm:ss[Z]";
    var lang = deprecate("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.", function(key) {
        if (void 0 === key) return this.localeData(); else return this.locale(key);
    });
    function localeData() {
        return this._locale;
    }
    function startOf(units) {
        switch (units = normalizeUnits(units), units) {
          case "year":
            this.month(0);

          case "quarter":
          case "month":
            this.date(1);

          case "week":
          case "isoWeek":
          case "day":
          case "date":
            this.hours(0);

          case "hour":
            this.minutes(0);

          case "minute":
            this.seconds(0);

          case "second":
            this.milliseconds(0);
        }
        if ("week" === units) this.weekday(0);
        if ("isoWeek" === units) this.isoWeekday(1);
        if ("quarter" === units) this.month(3 * Math.floor(this.month() / 3));
        return this;
    }
    function endOf(units) {
        if (units = normalizeUnits(units), void 0 === units || "millisecond" === units) return this;
        if ("date" === units) units = "day";
        return this.startOf(units).add(1, "isoWeek" === units ? "week" : units).subtract(1, "ms");
    }
    function valueOf() {
        return this._d.valueOf() - 6e4 * (this._offset || 0);
    }
    function unix() {
        return Math.floor(this.valueOf() / 1e3);
    }
    function toDate() {
        return new Date(this.valueOf());
    }
    function toArray() {
        var m = this;
        return [ m.year(), m.month(), m.date(), m.hour(), m.minute(), m.second(), m.millisecond() ];
    }
    function toObject() {
        var m = this;
        return {
            years: m.year(),
            months: m.month(),
            date: m.date(),
            hours: m.hours(),
            minutes: m.minutes(),
            seconds: m.seconds(),
            milliseconds: m.milliseconds()
        };
    }
    function toJSON() {
        return this.isValid() ? this.toISOString() : null;
    }
    function isValid$2() {
        return isValid(this);
    }
    function parsingFlags() {
        return extend({}, getParsingFlags(this));
    }
    function invalidAt() {
        return getParsingFlags(this).overflow;
    }
    function creationData() {
        return {
            input: this._i,
            format: this._f,
            locale: this._locale,
            isUTC: this._isUTC,
            strict: this._strict
        };
    }
    function addWeekYearFormatToken(token, getter) {
        addFormatToken(0, [ token, token.length ], 0, getter);
    }
    function getSetWeekYear(input) {
        return getSetWeekYearHelper.call(this, input, this.week(), this.weekday(), this.localeData()._week.dow, this.localeData()._week.doy);
    }
    function getSetISOWeekYear(input) {
        return getSetWeekYearHelper.call(this, input, this.isoWeek(), this.isoWeekday(), 1, 4);
    }
    function getISOWeeksInYear() {
        return weeksInYear(this.year(), 1, 4);
    }
    function getWeeksInYear() {
        var weekInfo = this.localeData()._week;
        return weeksInYear(this.year(), weekInfo.dow, weekInfo.doy);
    }
    function getSetWeekYearHelper(input, week, weekday, dow, doy) {
        var weeksTarget;
        if (null == input) return weekOfYear(this, dow, doy).year; else {
            if (weeksTarget = weeksInYear(input, dow, doy), week > weeksTarget) week = weeksTarget;
            return setWeekAll.call(this, input, week, weekday, dow, doy);
        }
    }
    function setWeekAll(weekYear, week, weekday, dow, doy) {
        var dayOfYearData = dayOfYearFromWeeks(weekYear, week, weekday, dow, doy), date = createUTCDate(dayOfYearData.year, 0, dayOfYearData.dayOfYear);
        return this.year(date.getUTCFullYear()), this.month(date.getUTCMonth()), this.date(date.getUTCDate()), 
        this;
    }
    function getSetQuarter(input) {
        return null == input ? Math.ceil((this.month() + 1) / 3) : this.month(3 * (input - 1) + this.month() % 3);
    }
    addFormatToken(0, [ "gg", 2 ], 0, function() {
        return this.weekYear() % 100;
    }), addFormatToken(0, [ "GG", 2 ], 0, function() {
        return this.isoWeekYear() % 100;
    }), addWeekYearFormatToken("gggg", "weekYear"), addWeekYearFormatToken("ggggg", "weekYear"), 
    addWeekYearFormatToken("GGGG", "isoWeekYear"), addWeekYearFormatToken("GGGGG", "isoWeekYear"), 
    addUnitAlias("weekYear", "gg"), addUnitAlias("isoWeekYear", "GG"), addUnitPriority("weekYear", 1), 
    addUnitPriority("isoWeekYear", 1), addRegexToken("G", matchSigned), addRegexToken("g", matchSigned), 
    addRegexToken("GG", match1to2, match2), addRegexToken("gg", match1to2, match2), 
    addRegexToken("GGGG", match1to4, match4), addRegexToken("gggg", match1to4, match4), 
    addRegexToken("GGGGG", match1to6, match6), addRegexToken("ggggg", match1to6, match6), 
    addWeekParseToken([ "gggg", "ggggg", "GGGG", "GGGGG" ], function(input, week, config, token) {
        week[token.substr(0, 2)] = toInt(input);
    }), addWeekParseToken([ "gg", "GG" ], function(input, week, config, token) {
        week[token] = hooks.parseTwoDigitYear(input);
    }), addFormatToken("Q", 0, "Qo", "quarter"), addUnitAlias("quarter", "Q"), addUnitPriority("quarter", 7), 
    addRegexToken("Q", match1), addParseToken("Q", function(input, array) {
        array[MONTH] = 3 * (toInt(input) - 1);
    }), addFormatToken("D", [ "DD", 2 ], "Do", "date"), addUnitAlias("date", "D"), addUnitPriority("date", 9), 
    addRegexToken("D", match1to2), addRegexToken("DD", match1to2, match2), addRegexToken("Do", function(isStrict, locale) {
        return isStrict ? locale._dayOfMonthOrdinalParse || locale._ordinalParse : locale._dayOfMonthOrdinalParseLenient;
    }), addParseToken([ "D", "DD" ], DATE), addParseToken("Do", function(input, array) {
        array[DATE] = toInt(input.match(match1to2)[0]);
    });
    var getSetDayOfMonth = makeGetSet("Date", true);
    function getSetDayOfYear(input) {
        var dayOfYear = Math.round((this.clone().startOf("day") - this.clone().startOf("year")) / 864e5) + 1;
        return null == input ? dayOfYear : this.add(input - dayOfYear, "d");
    }
    addFormatToken("DDD", [ "DDDD", 3 ], "DDDo", "dayOfYear"), addUnitAlias("dayOfYear", "DDD"), 
    addUnitPriority("dayOfYear", 4), addRegexToken("DDD", match1to3), addRegexToken("DDDD", match3), 
    addParseToken([ "DDD", "DDDD" ], function(input, array, config) {
        config._dayOfYear = toInt(input);
    }), addFormatToken("m", [ "mm", 2 ], 0, "minute"), addUnitAlias("minute", "m"), 
    addUnitPriority("minute", 14), addRegexToken("m", match1to2), addRegexToken("mm", match1to2, match2), 
    addParseToken([ "m", "mm" ], MINUTE);
    var getSetMinute = makeGetSet("Minutes", false);
    addFormatToken("s", [ "ss", 2 ], 0, "second"), addUnitAlias("second", "s"), addUnitPriority("second", 15), 
    addRegexToken("s", match1to2), addRegexToken("ss", match1to2, match2), addParseToken([ "s", "ss" ], SECOND);
    var getSetSecond = makeGetSet("Seconds", false);
    var token;
    for (addFormatToken("S", 0, 0, function() {
        return ~~(this.millisecond() / 100);
    }), addFormatToken(0, [ "SS", 2 ], 0, function() {
        return ~~(this.millisecond() / 10);
    }), addFormatToken(0, [ "SSS", 3 ], 0, "millisecond"), addFormatToken(0, [ "SSSS", 4 ], 0, function() {
        return 10 * this.millisecond();
    }), addFormatToken(0, [ "SSSSS", 5 ], 0, function() {
        return 100 * this.millisecond();
    }), addFormatToken(0, [ "SSSSSS", 6 ], 0, function() {
        return 1e3 * this.millisecond();
    }), addFormatToken(0, [ "SSSSSSS", 7 ], 0, function() {
        return 1e4 * this.millisecond();
    }), addFormatToken(0, [ "SSSSSSSS", 8 ], 0, function() {
        return 1e5 * this.millisecond();
    }), addFormatToken(0, [ "SSSSSSSSS", 9 ], 0, function() {
        return 1e6 * this.millisecond();
    }), addUnitAlias("millisecond", "ms"), addUnitPriority("millisecond", 16), addRegexToken("S", match1to3, match1), 
    addRegexToken("SS", match1to3, match2), addRegexToken("SSS", match1to3, match3), 
    token = "SSSS"; token.length <= 9; token += "S") addRegexToken(token, matchUnsigned);
    function parseMs(input, array) {
        array[MILLISECOND] = toInt(1e3 * ("0." + input));
    }
    for (token = "S"; token.length <= 9; token += "S") addParseToken(token, parseMs);
    var getSetMillisecond = makeGetSet("Milliseconds", false);
    function getZoneAbbr() {
        return this._isUTC ? "UTC" : "";
    }
    function getZoneName() {
        return this._isUTC ? "Coordinated Universal Time" : "";
    }
    addFormatToken("z", 0, 0, "zoneAbbr"), addFormatToken("zz", 0, 0, "zoneName");
    var proto = Moment.prototype;
    function createUnix(input) {
        return createLocal(1e3 * input);
    }
    function createInZone() {
        return createLocal.apply(null, arguments).parseZone();
    }
    function preParsePostFormat(string) {
        return string;
    }
    proto.add = add, proto.calendar = calendar$1, proto.clone = clone, proto.diff = diff, 
    proto.endOf = endOf, proto.format = format, proto.from = from, proto.fromNow = fromNow, 
    proto.to = to, proto.toNow = toNow, proto.get = stringGet, proto.invalidAt = invalidAt, 
    proto.isAfter = isAfter, proto.isBefore = isBefore, proto.isBetween = isBetween, 
    proto.isSame = isSame, proto.isSameOrAfter = isSameOrAfter, proto.isSameOrBefore = isSameOrBefore, 
    proto.isValid = isValid$2, proto.lang = lang, proto.locale = locale, proto.localeData = localeData, 
    proto.max = prototypeMax, proto.min = prototypeMin, proto.parsingFlags = parsingFlags, 
    proto.set = stringSet, proto.startOf = startOf, proto.subtract = subtract, proto.toArray = toArray, 
    proto.toObject = toObject, proto.toDate = toDate, proto.toISOString = toISOString, 
    proto.inspect = inspect, proto.toJSON = toJSON, proto.toString = toString, proto.unix = unix, 
    proto.valueOf = valueOf, proto.creationData = creationData, proto.year = getSetYear, 
    proto.isLeapYear = getIsLeapYear, proto.weekYear = getSetWeekYear, proto.isoWeekYear = getSetISOWeekYear, 
    proto.quarter = proto.quarters = getSetQuarter, proto.month = getSetMonth, proto.daysInMonth = getDaysInMonth, 
    proto.week = proto.weeks = getSetWeek, proto.isoWeek = proto.isoWeeks = getSetISOWeek, 
    proto.weeksInYear = getWeeksInYear, proto.isoWeeksInYear = getISOWeeksInYear, proto.date = getSetDayOfMonth, 
    proto.day = proto.days = getSetDayOfWeek, proto.weekday = getSetLocaleDayOfWeek, 
    proto.isoWeekday = getSetISODayOfWeek, proto.dayOfYear = getSetDayOfYear, proto.hour = proto.hours = getSetHour, 
    proto.minute = proto.minutes = getSetMinute, proto.second = proto.seconds = getSetSecond, 
    proto.millisecond = proto.milliseconds = getSetMillisecond, proto.utcOffset = getSetOffset, 
    proto.utc = setOffsetToUTC, proto.local = setOffsetToLocal, proto.parseZone = setOffsetToParsedOffset, 
    proto.hasAlignedHourOffset = hasAlignedHourOffset, proto.isDST = isDaylightSavingTime, 
    proto.isLocal = isLocal, proto.isUtcOffset = isUtcOffset, proto.isUtc = isUtc, proto.isUTC = isUtc, 
    proto.zoneAbbr = getZoneAbbr, proto.zoneName = getZoneName, proto.dates = deprecate("dates accessor is deprecated. Use date instead.", getSetDayOfMonth), 
    proto.months = deprecate("months accessor is deprecated. Use month instead", getSetMonth), 
    proto.years = deprecate("years accessor is deprecated. Use year instead", getSetYear), 
    proto.zone = deprecate("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/", getSetZone), 
    proto.isDSTShifted = deprecate("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information", isDaylightSavingTimeShifted);
    var proto$1 = Locale.prototype;
    function get$1(format, index, field, setter) {
        var locale = getLocale();
        var utc = createUTC().set(setter, index);
        return locale[field](utc, format);
    }
    function listMonthsImpl(format, index, field) {
        if (isNumber(format)) index = format, format = void 0;
        if (format = format || "", null != index) return get$1(format, index, field, "month");
        var i;
        var out = [];
        for (i = 0; i < 12; i++) out[i] = get$1(format, i, field, "month");
        return out;
    }
    function listWeekdaysImpl(localeSorted, format, index, field) {
        if ("boolean" === typeof localeSorted) {
            if (isNumber(format)) index = format, format = void 0;
            format = format || "";
        } else {
            if (format = localeSorted, index = format, localeSorted = false, isNumber(format)) index = format, 
            format = void 0;
            format = format || "";
        }
        var locale = getLocale(), shift = localeSorted ? locale._week.dow : 0;
        if (null != index) return get$1(format, (index + shift) % 7, field, "day");
        var i;
        var out = [];
        for (i = 0; i < 7; i++) out[i] = get$1(format, (i + shift) % 7, field, "day");
        return out;
    }
    function listMonths(format, index) {
        return listMonthsImpl(format, index, "months");
    }
    function listMonthsShort(format, index) {
        return listMonthsImpl(format, index, "monthsShort");
    }
    function listWeekdays(localeSorted, format, index) {
        return listWeekdaysImpl(localeSorted, format, index, "weekdays");
    }
    function listWeekdaysShort(localeSorted, format, index) {
        return listWeekdaysImpl(localeSorted, format, index, "weekdaysShort");
    }
    function listWeekdaysMin(localeSorted, format, index) {
        return listWeekdaysImpl(localeSorted, format, index, "weekdaysMin");
    }
    proto$1.calendar = calendar, proto$1.longDateFormat = longDateFormat, proto$1.invalidDate = invalidDate, 
    proto$1.ordinal = ordinal, proto$1.preparse = preParsePostFormat, proto$1.postformat = preParsePostFormat, 
    proto$1.relativeTime = relativeTime, proto$1.pastFuture = pastFuture, proto$1.set = set, 
    proto$1.months = localeMonths, proto$1.monthsShort = localeMonthsShort, proto$1.monthsParse = localeMonthsParse, 
    proto$1.monthsRegex = monthsRegex, proto$1.monthsShortRegex = monthsShortRegex, 
    proto$1.week = localeWeek, proto$1.firstDayOfYear = localeFirstDayOfYear, proto$1.firstDayOfWeek = localeFirstDayOfWeek, 
    proto$1.weekdays = localeWeekdays, proto$1.weekdaysMin = localeWeekdaysMin, proto$1.weekdaysShort = localeWeekdaysShort, 
    proto$1.weekdaysParse = localeWeekdaysParse, proto$1.weekdaysRegex = weekdaysRegex, 
    proto$1.weekdaysShortRegex = weekdaysShortRegex, proto$1.weekdaysMinRegex = weekdaysMinRegex, 
    proto$1.isPM = localeIsPM, proto$1.meridiem = localeMeridiem, getSetGlobalLocale("en", {
        dayOfMonthOrdinalParse: /\d{1,2}(th|st|nd|rd)/,
        ordinal: function(number) {
            var b = number % 10, output = 1 === toInt(number % 100 / 10) ? "th" : 1 === b ? "st" : 2 === b ? "nd" : 3 === b ? "rd" : "th";
            return number + output;
        }
    }), hooks.lang = deprecate("moment.lang is deprecated. Use moment.locale instead.", getSetGlobalLocale), 
    hooks.langData = deprecate("moment.langData is deprecated. Use moment.localeData instead.", getLocale);
    var mathAbs = Math.abs;
    function abs() {
        var data = this._data;
        return this._milliseconds = mathAbs(this._milliseconds), this._days = mathAbs(this._days), 
        this._months = mathAbs(this._months), data.milliseconds = mathAbs(data.milliseconds), 
        data.seconds = mathAbs(data.seconds), data.minutes = mathAbs(data.minutes), data.hours = mathAbs(data.hours), 
        data.months = mathAbs(data.months), data.years = mathAbs(data.years), this;
    }
    function addSubtract$1(duration, input, value, direction) {
        var other = createDuration(input, value);
        return duration._milliseconds += direction * other._milliseconds, duration._days += direction * other._days, 
        duration._months += direction * other._months, duration._bubble();
    }
    function add$1(input, value) {
        return addSubtract$1(this, input, value, 1);
    }
    function subtract$1(input, value) {
        return addSubtract$1(this, input, value, -1);
    }
    function absCeil(number) {
        if (number < 0) return Math.floor(number); else return Math.ceil(number);
    }
    function bubble() {
        var milliseconds = this._milliseconds;
        var days = this._days;
        var months = this._months;
        var data = this._data;
        var seconds, minutes, hours, years, monthsFromDays;
        if (!(milliseconds >= 0 && days >= 0 && months >= 0 || milliseconds <= 0 && days <= 0 && months <= 0)) milliseconds += 864e5 * absCeil(monthsToDays(months) + days), 
        days = 0, months = 0;
        return data.milliseconds = milliseconds % 1e3, seconds = absFloor(milliseconds / 1e3), 
        data.seconds = seconds % 60, minutes = absFloor(seconds / 60), data.minutes = minutes % 60, 
        hours = absFloor(minutes / 60), data.hours = hours % 24, days += absFloor(hours / 24), 
        monthsFromDays = absFloor(daysToMonths(days)), months += monthsFromDays, days -= absCeil(monthsToDays(monthsFromDays)), 
        years = absFloor(months / 12), months %= 12, data.days = days, data.months = months, 
        data.years = years, this;
    }
    function daysToMonths(days) {
        return 4800 * days / 146097;
    }
    function monthsToDays(months) {
        return 146097 * months / 4800;
    }
    function as(units) {
        if (!this.isValid()) return NaN;
        var days;
        var months;
        var milliseconds = this._milliseconds;
        if (units = normalizeUnits(units), "month" === units || "year" === units) return days = this._days + milliseconds / 864e5, 
        months = this._months + daysToMonths(days), "month" === units ? months : months / 12; else switch (days = this._days + Math.round(monthsToDays(this._months)), 
        units) {
          case "week":
            return days / 7 + milliseconds / 6048e5;

          case "day":
            return days + milliseconds / 864e5;

          case "hour":
            return 24 * days + milliseconds / 36e5;

          case "minute":
            return 1440 * days + milliseconds / 6e4;

          case "second":
            return 86400 * days + milliseconds / 1e3;

          case "millisecond":
            return Math.floor(864e5 * days) + milliseconds;

          default:
            throw new Error("Unknown unit " + units);
        }
    }
    function valueOf$1() {
        if (!this.isValid()) return NaN; else return this._milliseconds + 864e5 * this._days + this._months % 12 * 2592e6 + 31536e6 * toInt(this._months / 12);
    }
    function makeAs(alias) {
        return function() {
            return this.as(alias);
        };
    }
    var asMilliseconds = makeAs("ms");
    var asSeconds = makeAs("s");
    var asMinutes = makeAs("m");
    var asHours = makeAs("h");
    var asDays = makeAs("d");
    var asWeeks = makeAs("w");
    var asMonths = makeAs("M");
    var asYears = makeAs("y");
    function clone$1() {
        return createDuration(this);
    }
    function get$2(units) {
        return units = normalizeUnits(units), this.isValid() ? this[units + "s"]() : NaN;
    }
    function makeGetter(name) {
        return function() {
            return this.isValid() ? this._data[name] : NaN;
        };
    }
    var milliseconds = makeGetter("milliseconds");
    var seconds = makeGetter("seconds");
    var minutes = makeGetter("minutes");
    var hours = makeGetter("hours");
    var days = makeGetter("days");
    var months = makeGetter("months");
    var years = makeGetter("years");
    function weeks() {
        return absFloor(this.days() / 7);
    }
    var round = Math.round;
    var thresholds = {
        ss: 44,
        s: 45,
        m: 45,
        h: 22,
        d: 26,
        M: 11
    };
    function substituteTimeAgo(string, number, withoutSuffix, isFuture, locale) {
        return locale.relativeTime(number || 1, !!withoutSuffix, string, isFuture);
    }
    function relativeTime$1(posNegDuration, withoutSuffix, locale) {
        var duration = createDuration(posNegDuration).abs();
        var seconds = round(duration.as("s"));
        var minutes = round(duration.as("m"));
        var hours = round(duration.as("h"));
        var days = round(duration.as("d"));
        var months = round(duration.as("M"));
        var years = round(duration.as("y"));
        var a = seconds <= thresholds.ss && [ "s", seconds ] || seconds < thresholds.s && [ "ss", seconds ] || minutes <= 1 && [ "m" ] || minutes < thresholds.m && [ "mm", minutes ] || hours <= 1 && [ "h" ] || hours < thresholds.h && [ "hh", hours ] || days <= 1 && [ "d" ] || days < thresholds.d && [ "dd", days ] || months <= 1 && [ "M" ] || months < thresholds.M && [ "MM", months ] || years <= 1 && [ "y" ] || [ "yy", years ];
        return a[2] = withoutSuffix, a[3] = +posNegDuration > 0, a[4] = locale, substituteTimeAgo.apply(null, a);
    }
    function getSetRelativeTimeRounding(roundingFunction) {
        if (void 0 === roundingFunction) return round;
        if ("function" === typeof roundingFunction) return round = roundingFunction, true; else return false;
    }
    function getSetRelativeTimeThreshold(threshold, limit) {
        if (void 0 === thresholds[threshold]) return false;
        if (void 0 === limit) return thresholds[threshold];
        if (thresholds[threshold] = limit, "s" === threshold) thresholds.ss = limit - 1;
        return true;
    }
    function humanize(withSuffix) {
        if (!this.isValid()) return this.localeData().invalidDate();
        var locale = this.localeData();
        var output = relativeTime$1(this, !withSuffix, locale);
        if (withSuffix) output = locale.pastFuture(+this, output);
        return locale.postformat(output);
    }
    var abs$1 = Math.abs;
    function sign(x) {
        return (x > 0) - (x < 0) || +x;
    }
    function toISOString$1() {
        if (!this.isValid()) return this.localeData().invalidDate();
        var seconds = abs$1(this._milliseconds) / 1e3;
        var days = abs$1(this._days);
        var months = abs$1(this._months);
        var minutes, hours, years;
        minutes = absFloor(seconds / 60), hours = absFloor(minutes / 60), seconds %= 60, 
        minutes %= 60, years = absFloor(months / 12), months %= 12;
        var Y = years;
        var M = months;
        var D = days;
        var h = hours;
        var m = minutes;
        var s = seconds ? seconds.toFixed(3).replace(/\.?0+$/, "") : "";
        var total = this.asSeconds();
        if (!total) return "P0D";
        var totalSign = total < 0 ? "-" : "";
        var ymSign = sign(this._months) !== sign(total) ? "-" : "";
        var daysSign = sign(this._days) !== sign(total) ? "-" : "";
        var hmsSign = sign(this._milliseconds) !== sign(total) ? "-" : "";
        return totalSign + "P" + (Y ? ymSign + Y + "Y" : "") + (M ? ymSign + M + "M" : "") + (D ? daysSign + D + "D" : "") + (h || m || s ? "T" : "") + (h ? hmsSign + h + "H" : "") + (m ? hmsSign + m + "M" : "") + (s ? hmsSign + s + "S" : "");
    }
    var proto$2 = Duration.prototype;
    return proto$2.isValid = isValid$1, proto$2.abs = abs, proto$2.add = add$1, proto$2.subtract = subtract$1, 
    proto$2.as = as, proto$2.asMilliseconds = asMilliseconds, proto$2.asSeconds = asSeconds, 
    proto$2.asMinutes = asMinutes, proto$2.asHours = asHours, proto$2.asDays = asDays, 
    proto$2.asWeeks = asWeeks, proto$2.asMonths = asMonths, proto$2.asYears = asYears, 
    proto$2.valueOf = valueOf$1, proto$2._bubble = bubble, proto$2.clone = clone$1, 
    proto$2.get = get$2, proto$2.milliseconds = milliseconds, proto$2.seconds = seconds, 
    proto$2.minutes = minutes, proto$2.hours = hours, proto$2.days = days, proto$2.weeks = weeks, 
    proto$2.months = months, proto$2.years = years, proto$2.humanize = humanize, proto$2.toISOString = toISOString$1, 
    proto$2.toString = toISOString$1, proto$2.toJSON = toISOString$1, proto$2.locale = locale, 
    proto$2.localeData = localeData, proto$2.toIsoString = deprecate("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)", toISOString$1), 
    proto$2.lang = lang, addFormatToken("X", 0, 0, "unix"), addFormatToken("x", 0, 0, "valueOf"), 
    addRegexToken("x", matchSigned), addRegexToken("X", matchTimestamp), addParseToken("X", function(input, array, config) {
        config._d = new Date(1e3 * parseFloat(input, 10));
    }), addParseToken("x", function(input, array, config) {
        config._d = new Date(toInt(input));
    }), hooks.version = "2.21.0", setHookCallback(createLocal), hooks.fn = proto, hooks.min = min, 
    hooks.max = max, hooks.now = now, hooks.utc = createUTC, hooks.unix = createUnix, 
    hooks.months = listMonths, hooks.isDate = isDate, hooks.locale = getSetGlobalLocale, 
    hooks.invalid = createInvalid, hooks.duration = createDuration, hooks.isMoment = isMoment, 
    hooks.weekdays = listWeekdays, hooks.parseZone = createInZone, hooks.localeData = getLocale, 
    hooks.isDuration = isDuration, hooks.monthsShort = listMonthsShort, hooks.weekdaysMin = listWeekdaysMin, 
    hooks.defineLocale = defineLocale, hooks.updateLocale = updateLocale, hooks.locales = listLocales, 
    hooks.weekdaysShort = listWeekdaysShort, hooks.normalizeUnits = normalizeUnits, 
    hooks.relativeTimeRounding = getSetRelativeTimeRounding, hooks.relativeTimeThreshold = getSetRelativeTimeThreshold, 
    hooks.calendarFormat = getCalendarFormat, hooks.prototype = proto, hooks.HTML5_FMT = {
        DATETIME_LOCAL: "YYYY-MM-DDTHH:mm",
        DATETIME_LOCAL_SECONDS: "YYYY-MM-DDTHH:mm:ss",
        DATETIME_LOCAL_MS: "YYYY-MM-DDTHH:mm:ss.SSS",
        DATE: "YYYY-MM-DD",
        TIME: "HH:mm",
        TIME_SECONDS: "HH:mm:ss",
        TIME_MS: "HH:mm:ss.SSS",
        WEEK: "YYYY-[W]WW",
        MONTH: "YYYY-MM"
    }, hooks;
}), function(window, factory) {
    if ("function" == typeof define && define.amd) define("jquery-bridget/jquery-bridget", [ "jquery" ], function(jQuery) {
        return factory(window, jQuery);
    }); else if ("object" == typeof module && module.exports) module.exports = factory(window, require("jquery")); else window.jQueryBridget = factory(window, window.jQuery);
}(window, function factory(window, jQuery) {
    "use strict";
    var arraySlice = Array.prototype.slice;
    var console = window.console;
    var logError = "undefined" == typeof console ? function() {} : function(message) {
        console.error(message);
    };
    function jQueryBridget(namespace, PluginClass, $) {
        if ($ = $ || jQuery || window.jQuery, $) {
            if (!PluginClass.prototype.option) PluginClass.prototype.option = function(opts) {
                if ($.isPlainObject(opts)) this.options = $.extend(true, this.options, opts);
            };
            $.fn[namespace] = function(arg0) {
                if ("string" == typeof arg0) {
                    var args = arraySlice.call(arguments, 1);
                    return methodCall(this, arg0, args);
                }
                return plainCall(this, arg0), this;
            }, updateJQuery($);
        }
        function methodCall($elems, methodName, args) {
            var returnValue;
            var pluginMethodStr = "$()." + namespace + '("' + methodName + '")';
            return $elems.each(function(i, elem) {
                var instance = $.data(elem, namespace);
                if (!instance) return logError(namespace + " not initialized. Cannot call methods, i.e. " + pluginMethodStr), 
                void 0;
                var method = instance[methodName];
                if (!method || "_" == methodName.charAt(0)) return logError(pluginMethodStr + " is not a valid method"), 
                void 0;
                var value = method.apply(instance, args);
                returnValue = void 0 === returnValue ? value : returnValue;
            }), void 0 !== returnValue ? returnValue : $elems;
        }
        function plainCall($elems, options) {
            $elems.each(function(i, elem) {
                var instance = $.data(elem, namespace);
                if (instance) instance.option(options), instance._init(); else instance = new PluginClass(elem, options), 
                $.data(elem, namespace, instance);
            });
        }
    }
    function updateJQuery($) {
        if (!(!$ || $ && $.bridget)) $.bridget = jQueryBridget;
    }
    return updateJQuery(jQuery || window.jQuery), jQueryBridget;
}), function(global, factory) {
    if ("function" == typeof define && define.amd) define("ev-emitter/ev-emitter", factory); else if ("object" == typeof module && module.exports) module.exports = factory(); else global.EvEmitter = factory();
}("undefined" != typeof window ? window : this, function() {
    function EvEmitter() {}
    var proto = EvEmitter.prototype;
    return proto.on = function(eventName, listener) {
        if (eventName && listener) {
            var events = this._events = this._events || {};
            var listeners = events[eventName] = events[eventName] || [];
            if (-1 == listeners.indexOf(listener)) listeners.push(listener);
            return this;
        }
    }, proto.once = function(eventName, listener) {
        if (eventName && listener) {
            this.on(eventName, listener);
            var onceEvents = this._onceEvents = this._onceEvents || {};
            var onceListeners = onceEvents[eventName] = onceEvents[eventName] || {};
            return onceListeners[listener] = true, this;
        }
    }, proto.off = function(eventName, listener) {
        var listeners = this._events && this._events[eventName];
        if (listeners && listeners.length) {
            var index = listeners.indexOf(listener);
            if (-1 != index) listeners.splice(index, 1);
            return this;
        }
    }, proto.emitEvent = function(eventName, args) {
        var listeners = this._events && this._events[eventName];
        if (listeners && listeners.length) {
            listeners = listeners.slice(0), args = args || [];
            var onceListeners = this._onceEvents && this._onceEvents[eventName];
            for (var i = 0; i < listeners.length; i++) {
                var listener = listeners[i];
                var isOnce = onceListeners && onceListeners[listener];
                if (isOnce) this.off(eventName, listener), delete onceListeners[listener];
                listener.apply(this, args);
            }
            return this;
        }
    }, proto.allOff = function() {
        delete this._events, delete this._onceEvents;
    }, EvEmitter;
}), function(window, factory) {
    "use strict";
    if ("function" == typeof define && define.amd) define("get-size/get-size", [], function() {
        return factory();
    }); else if ("object" == typeof module && module.exports) module.exports = factory(); else window.getSize = factory();
}(window, function factory() {
    "use strict";
    function getStyleSize(value) {
        var num = parseFloat(value);
        var isValid = -1 == value.indexOf("%") && !isNaN(num);
        return isValid && num;
    }
    function noop() {}
    var logError = "undefined" == typeof console ? noop : function(message) {
        void 0;
    };
    var measurements = [ "paddingLeft", "paddingRight", "paddingTop", "paddingBottom", "marginLeft", "marginRight", "marginTop", "marginBottom", "borderLeftWidth", "borderRightWidth", "borderTopWidth", "borderBottomWidth" ];
    var measurementsLength = measurements.length;
    function getZeroSize() {
        var size = {
            width: 0,
            height: 0,
            innerWidth: 0,
            innerHeight: 0,
            outerWidth: 0,
            outerHeight: 0
        };
        for (var i = 0; i < measurementsLength; i++) {
            var measurement = measurements[i];
            size[measurement] = 0;
        }
        return size;
    }
    function getStyle(elem) {
        var style = getComputedStyle(elem);
        if (!style) logError("Style returned " + style + ". Are you running this code in a hidden iframe on Firefox? " + "See http://bit.ly/getsizebug1");
        return style;
    }
    var isSetup = false;
    var isBoxSizeOuter;
    function setup() {
        if (!isSetup) {
            isSetup = true;
            var div = document.createElement("div");
            div.style.width = "200px", div.style.padding = "1px 2px 3px 4px", div.style.borderStyle = "solid", 
            div.style.borderWidth = "1px 2px 3px 4px", div.style.boxSizing = "border-box";
            var body = document.body || document.documentElement;
            body.appendChild(div);
            var style = getStyle(div);
            getSize.isBoxSizeOuter = isBoxSizeOuter = 200 == getStyleSize(style.width), body.removeChild(div);
        }
    }
    function getSize(elem) {
        if (setup(), "string" == typeof elem) elem = document.querySelector(elem);
        if (elem && "object" == typeof elem && elem.nodeType) {
            var style = getStyle(elem);
            if ("none" == style.display) return getZeroSize();
            var size = {};
            size.width = elem.offsetWidth, size.height = elem.offsetHeight;
            var isBorderBox = size.isBorderBox = "border-box" == style.boxSizing;
            for (var i = 0; i < measurementsLength; i++) {
                var measurement = measurements[i];
                var value = style[measurement];
                var num = parseFloat(value);
                size[measurement] = !isNaN(num) ? num : 0;
            }
            var paddingWidth = size.paddingLeft + size.paddingRight;
            var paddingHeight = size.paddingTop + size.paddingBottom;
            var marginWidth = size.marginLeft + size.marginRight;
            var marginHeight = size.marginTop + size.marginBottom;
            var borderWidth = size.borderLeftWidth + size.borderRightWidth;
            var borderHeight = size.borderTopWidth + size.borderBottomWidth;
            var isBorderBoxSizeOuter = isBorderBox && isBoxSizeOuter;
            var styleWidth = getStyleSize(style.width);
            if (false !== styleWidth) size.width = styleWidth + (isBorderBoxSizeOuter ? 0 : paddingWidth + borderWidth);
            var styleHeight = getStyleSize(style.height);
            if (false !== styleHeight) size.height = styleHeight + (isBorderBoxSizeOuter ? 0 : paddingHeight + borderHeight);
            return size.innerWidth = size.width - (paddingWidth + borderWidth), size.innerHeight = size.height - (paddingHeight + borderHeight), 
            size.outerWidth = size.width + marginWidth, size.outerHeight = size.height + marginHeight, 
            size;
        }
    }
    return getSize;
}), function(window, factory) {
    "use strict";
    if ("function" == typeof define && define.amd) define("desandro-matches-selector/matches-selector", factory); else if ("object" == typeof module && module.exports) module.exports = factory(); else window.matchesSelector = factory();
}(window, function factory() {
    "use strict";
    var matchesMethod = function() {
        var ElemProto = window.Element.prototype;
        if (ElemProto.matches) return "matches";
        if (ElemProto.matchesSelector) return "matchesSelector";
        var prefixes = [ "webkit", "moz", "ms", "o" ];
        for (var i = 0; i < prefixes.length; i++) {
            var prefix = prefixes[i];
            var method = prefix + "MatchesSelector";
            if (ElemProto[method]) return method;
        }
    }();
    return function matchesSelector(elem, selector) {
        return elem[matchesMethod](selector);
    };
}), function(window, factory) {
    if ("function" == typeof define && define.amd) define("fizzy-ui-utils/utils", [ "desandro-matches-selector/matches-selector" ], function(matchesSelector) {
        return factory(window, matchesSelector);
    }); else if ("object" == typeof module && module.exports) module.exports = factory(window, require("desandro-matches-selector")); else window.fizzyUIUtils = factory(window, window.matchesSelector);
}(window, function factory(window, matchesSelector) {
    var utils = {};
    utils.extend = function(a, b) {
        for (var prop in b) a[prop] = b[prop];
        return a;
    }, utils.modulo = function(num, div) {
        return (num % div + div) % div;
    }, utils.makeArray = function(obj) {
        var ary = [];
        if (Array.isArray(obj)) ary = obj; else if (obj && "object" == typeof obj && "number" == typeof obj.length) for (var i = 0; i < obj.length; i++) ary.push(obj[i]); else ary.push(obj);
        return ary;
    }, utils.removeFrom = function(ary, obj) {
        var index = ary.indexOf(obj);
        if (-1 != index) ary.splice(index, 1);
    }, utils.getParent = function(elem, selector) {
        for (;elem.parentNode && elem != document.body; ) if (elem = elem.parentNode, matchesSelector(elem, selector)) return elem;
    }, utils.getQueryElement = function(elem) {
        if ("string" == typeof elem) return document.querySelector(elem); else return elem;
    }, utils.handleEvent = function(event) {
        var method = "on" + event.type;
        if (this[method]) this[method](event);
    }, utils.filterFindElements = function(elems, selector) {
        elems = utils.makeArray(elems);
        var ffElems = [];
        return elems.forEach(function(elem) {
            if (elem instanceof HTMLElement) {
                if (!selector) return ffElems.push(elem), void 0;
                if (matchesSelector(elem, selector)) ffElems.push(elem);
                var childElems = elem.querySelectorAll(selector);
                for (var i = 0; i < childElems.length; i++) ffElems.push(childElems[i]);
            }
        }), ffElems;
    }, utils.debounceMethod = function(_class, methodName, threshold) {
        var method = _class.prototype[methodName];
        var timeoutName = methodName + "Timeout";
        _class.prototype[methodName] = function() {
            var timeout = this[timeoutName];
            if (timeout) clearTimeout(timeout);
            var args = arguments;
            var _this = this;
            this[timeoutName] = setTimeout(function() {
                method.apply(_this, args), delete _this[timeoutName];
            }, threshold || 100);
        };
    }, utils.docReady = function(callback) {
        var readyState = document.readyState;
        if ("complete" == readyState || "interactive" == readyState) setTimeout(callback); else document.addEventListener("DOMContentLoaded", callback);
    }, utils.toDashed = function(str) {
        return str.replace(/(.)([A-Z])/g, function(match, $1, $2) {
            return $1 + "-" + $2;
        }).toLowerCase();
    };
    var console = window.console;
    return utils.htmlInit = function(WidgetClass, namespace) {
        utils.docReady(function() {
            var dashedNamespace = utils.toDashed(namespace);
            var dataAttr = "data-" + dashedNamespace;
            var dataAttrElems = document.querySelectorAll("[" + dataAttr + "]");
            var jsDashElems = document.querySelectorAll(".js-" + dashedNamespace);
            var elems = utils.makeArray(dataAttrElems).concat(utils.makeArray(jsDashElems));
            var dataOptionsAttr = dataAttr + "-options";
            var jQuery = window.jQuery;
            elems.forEach(function(elem) {
                var attr = elem.getAttribute(dataAttr) || elem.getAttribute(dataOptionsAttr);
                var options;
                try {
                    options = attr && JSON.parse(attr);
                } catch (error) {
                    if (console) console.error("Error parsing " + dataAttr + " on " + elem.className + ": " + error);
                    return;
                }
                var instance = new WidgetClass(elem, options);
                if (jQuery) jQuery.data(elem, namespace, instance);
            });
        });
    }, utils;
}), function(window, factory) {
    if ("function" == typeof define && define.amd) define("outlayer/item", [ "ev-emitter/ev-emitter", "get-size/get-size" ], factory); else if ("object" == typeof module && module.exports) module.exports = factory(require("ev-emitter"), require("get-size")); else window.Outlayer = {}, 
    window.Outlayer.Item = factory(window.EvEmitter, window.getSize);
}(window, function factory(EvEmitter, getSize) {
    "use strict";
    function isEmptyObj(obj) {
        for (var prop in obj) return false;
        return null, true;
    }
    var docElemStyle = document.documentElement.style;
    var transitionProperty = "string" == typeof docElemStyle.transition ? "transition" : "WebkitTransition";
    var transformProperty = "string" == typeof docElemStyle.transform ? "transform" : "WebkitTransform";
    var transitionEndEvent = {
        WebkitTransition: "webkitTransitionEnd",
        transition: "transitionend"
    }[transitionProperty];
    var vendorProperties = {
        transform: transformProperty,
        transition: transitionProperty,
        transitionDuration: transitionProperty + "Duration",
        transitionProperty: transitionProperty + "Property",
        transitionDelay: transitionProperty + "Delay"
    };
    function Item(element, layout) {
        if (element) this.element = element, this.layout = layout, this.position = {
            x: 0,
            y: 0
        }, this._create();
    }
    var proto = Item.prototype = Object.create(EvEmitter.prototype);
    function toDashedAll(str) {
        return str.replace(/([A-Z])/g, function($1) {
            return "-" + $1.toLowerCase();
        });
    }
    proto.constructor = Item, proto._create = function() {
        this._transn = {
            ingProperties: {},
            clean: {},
            onEnd: {}
        }, this.css({
            position: "absolute"
        });
    }, proto.handleEvent = function(event) {
        var method = "on" + event.type;
        if (this[method]) this[method](event);
    }, proto.getSize = function() {
        this.size = getSize(this.element);
    }, proto.css = function(style) {
        var elemStyle = this.element.style;
        for (var prop in style) {
            var supportedProp = vendorProperties[prop] || prop;
            elemStyle[supportedProp] = style[prop];
        }
    }, proto.getPosition = function() {
        var style = getComputedStyle(this.element);
        var isOriginLeft = this.layout._getOption("originLeft");
        var isOriginTop = this.layout._getOption("originTop");
        var xValue = style[isOriginLeft ? "left" : "right"];
        var yValue = style[isOriginTop ? "top" : "bottom"];
        var layoutSize = this.layout.size;
        var x = -1 != xValue.indexOf("%") ? parseFloat(xValue) / 100 * layoutSize.width : parseInt(xValue, 10);
        var y = -1 != yValue.indexOf("%") ? parseFloat(yValue) / 100 * layoutSize.height : parseInt(yValue, 10);
        x = isNaN(x) ? 0 : x, y = isNaN(y) ? 0 : y, x -= isOriginLeft ? layoutSize.paddingLeft : layoutSize.paddingRight, 
        y -= isOriginTop ? layoutSize.paddingTop : layoutSize.paddingBottom, this.position.x = x, 
        this.position.y = y;
    }, proto.layoutPosition = function() {
        var layoutSize = this.layout.size;
        var style = {};
        var isOriginLeft = this.layout._getOption("originLeft");
        var isOriginTop = this.layout._getOption("originTop");
        var xPadding = isOriginLeft ? "paddingLeft" : "paddingRight";
        var xProperty = isOriginLeft ? "left" : "right";
        var xResetProperty = isOriginLeft ? "right" : "left";
        var x = this.position.x + layoutSize[xPadding];
        style[xProperty] = this.getXValue(x), style[xResetProperty] = "";
        var yPadding = isOriginTop ? "paddingTop" : "paddingBottom";
        var yProperty = isOriginTop ? "top" : "bottom";
        var yResetProperty = isOriginTop ? "bottom" : "top";
        var y = this.position.y + layoutSize[yPadding];
        style[yProperty] = this.getYValue(y), style[yResetProperty] = "", this.css(style), 
        this.emitEvent("layout", [ this ]);
    }, proto.getXValue = function(x) {
        var isHorizontal = this.layout._getOption("horizontal");
        return this.layout.options.percentPosition && !isHorizontal ? x / this.layout.size.width * 100 + "%" : x + "px";
    }, proto.getYValue = function(y) {
        var isHorizontal = this.layout._getOption("horizontal");
        return this.layout.options.percentPosition && isHorizontal ? y / this.layout.size.height * 100 + "%" : y + "px";
    }, proto._transitionTo = function(x, y) {
        this.getPosition();
        var curX = this.position.x;
        var curY = this.position.y;
        var compareX = parseInt(x, 10);
        var compareY = parseInt(y, 10);
        var didNotMove = compareX === this.position.x && compareY === this.position.y;
        if (this.setPosition(x, y), didNotMove && !this.isTransitioning) return this.layoutPosition(), 
        void 0;
        var transX = x - curX;
        var transY = y - curY;
        var transitionStyle = {};
        transitionStyle.transform = this.getTranslate(transX, transY), this.transition({
            to: transitionStyle,
            onTransitionEnd: {
                transform: this.layoutPosition
            },
            isCleaning: true
        });
    }, proto.getTranslate = function(x, y) {
        var isOriginLeft = this.layout._getOption("originLeft");
        var isOriginTop = this.layout._getOption("originTop");
        return x = isOriginLeft ? x : -x, y = isOriginTop ? y : -y, "translate3d(" + x + "px, " + y + "px, 0)";
    }, proto.goTo = function(x, y) {
        this.setPosition(x, y), this.layoutPosition();
    }, proto.moveTo = proto._transitionTo, proto.setPosition = function(x, y) {
        this.position.x = parseInt(x, 10), this.position.y = parseInt(y, 10);
    }, proto._nonTransition = function(args) {
        if (this.css(args.to), args.isCleaning) this._removeStyles(args.to);
        for (var prop in args.onTransitionEnd) args.onTransitionEnd[prop].call(this);
    }, proto.transition = function(args) {
        if (!parseFloat(this.layout.options.transitionDuration)) return this._nonTransition(args), 
        void 0;
        var _transition = this._transn;
        for (var prop in args.onTransitionEnd) _transition.onEnd[prop] = args.onTransitionEnd[prop];
        for (prop in args.to) if (_transition.ingProperties[prop] = true, args.isCleaning) _transition.clean[prop] = true;
        if (args.from) {
            this.css(args.from);
            this.element.offsetHeight;
            null;
        }
        this.enableTransition(args.to), this.css(args.to), this.isTransitioning = true;
    };
    var transitionProps = "opacity," + toDashedAll(transformProperty);
    proto.enableTransition = function() {
        if (!this.isTransitioning) {
            var duration = this.layout.options.transitionDuration;
            duration = "number" == typeof duration ? duration + "ms" : duration, this.css({
                transitionProperty: transitionProps,
                transitionDuration: duration,
                transitionDelay: this.staggerDelay || 0
            }), this.element.addEventListener(transitionEndEvent, this, false);
        }
    }, proto.onwebkitTransitionEnd = function(event) {
        this.ontransitionend(event);
    }, proto.onotransitionend = function(event) {
        this.ontransitionend(event);
    };
    var dashedVendorProperties = {
        "-webkit-transform": "transform"
    };
    proto.ontransitionend = function(event) {
        if (event.target === this.element) {
            var _transition = this._transn;
            var propertyName = dashedVendorProperties[event.propertyName] || event.propertyName;
            if (delete _transition.ingProperties[propertyName], isEmptyObj(_transition.ingProperties)) this.disableTransition();
            if (propertyName in _transition.clean) this.element.style[event.propertyName] = "", 
            delete _transition.clean[propertyName];
            if (propertyName in _transition.onEnd) {
                var onTransitionEnd = _transition.onEnd[propertyName];
                onTransitionEnd.call(this), delete _transition.onEnd[propertyName];
            }
            this.emitEvent("transitionEnd", [ this ]);
        }
    }, proto.disableTransition = function() {
        this.removeTransitionStyles(), this.element.removeEventListener(transitionEndEvent, this, false), 
        this.isTransitioning = false;
    }, proto._removeStyles = function(style) {
        var cleanStyle = {};
        for (var prop in style) cleanStyle[prop] = "";
        this.css(cleanStyle);
    };
    var cleanTransitionStyle = {
        transitionProperty: "",
        transitionDuration: "",
        transitionDelay: ""
    };
    return proto.removeTransitionStyles = function() {
        this.css(cleanTransitionStyle);
    }, proto.stagger = function(delay) {
        delay = isNaN(delay) ? 0 : delay, this.staggerDelay = delay + "ms";
    }, proto.removeElem = function() {
        this.element.parentNode.removeChild(this.element), this.css({
            display: ""
        }), this.emitEvent("remove", [ this ]);
    }, proto.remove = function() {
        if (!transitionProperty || !parseFloat(this.layout.options.transitionDuration)) return this.removeElem(), 
        void 0;
        this.once("transitionEnd", function() {
            this.removeElem();
        }), this.hide();
    }, proto.reveal = function() {
        delete this.isHidden, this.css({
            display: ""
        });
        var options = this.layout.options;
        var onTransitionEnd = {};
        var transitionEndProperty = this.getHideRevealTransitionEndProperty("visibleStyle");
        onTransitionEnd[transitionEndProperty] = this.onRevealTransitionEnd, this.transition({
            from: options.hiddenStyle,
            to: options.visibleStyle,
            isCleaning: true,
            onTransitionEnd: onTransitionEnd
        });
    }, proto.onRevealTransitionEnd = function() {
        if (!this.isHidden) this.emitEvent("reveal");
    }, proto.getHideRevealTransitionEndProperty = function(styleProperty) {
        var optionStyle = this.layout.options[styleProperty];
        if (optionStyle.opacity) return "opacity";
        for (var prop in optionStyle) return prop;
    }, proto.hide = function() {
        this.isHidden = true, this.css({
            display: ""
        });
        var options = this.layout.options;
        var onTransitionEnd = {};
        var transitionEndProperty = this.getHideRevealTransitionEndProperty("hiddenStyle");
        onTransitionEnd[transitionEndProperty] = this.onHideTransitionEnd, this.transition({
            from: options.visibleStyle,
            to: options.hiddenStyle,
            isCleaning: true,
            onTransitionEnd: onTransitionEnd
        });
    }, proto.onHideTransitionEnd = function() {
        if (this.isHidden) this.css({
            display: "none"
        }), this.emitEvent("hide");
    }, proto.destroy = function() {
        this.css({
            position: "",
            left: "",
            right: "",
            top: "",
            bottom: "",
            transition: "",
            transform: ""
        });
    }, Item;
}), function(window, factory) {
    "use strict";
    if ("function" == typeof define && define.amd) define("outlayer/outlayer", [ "ev-emitter/ev-emitter", "get-size/get-size", "fizzy-ui-utils/utils", "./item" ], function(EvEmitter, getSize, utils, Item) {
        return factory(window, EvEmitter, getSize, utils, Item);
    }); else if ("object" == typeof module && module.exports) module.exports = factory(window, require("ev-emitter"), require("get-size"), require("fizzy-ui-utils"), require("./item")); else window.Outlayer = factory(window, window.EvEmitter, window.getSize, window.fizzyUIUtils, window.Outlayer.Item);
}(window, function factory(window, EvEmitter, getSize, utils, Item) {
    "use strict";
    var console = window.console;
    var jQuery = window.jQuery;
    var noop = function() {};
    var GUID = 0;
    var instances = {};
    function Outlayer(element, options) {
        var queryElement = utils.getQueryElement(element);
        if (queryElement) {
            if (this.element = queryElement, jQuery) this.$element = jQuery(this.element);
            this.options = utils.extend({}, this.constructor.defaults), this.option(options);
            var id = ++GUID;
            this.element.outlayerGUID = id, instances[id] = this, this._create();
            var isInitLayout = this._getOption("initLayout");
            if (isInitLayout) this.layout();
        } else if (console) console.error("Bad element for " + this.constructor.namespace + ": " + (queryElement || element));
    }
    Outlayer.namespace = "outlayer", Outlayer.Item = Item, Outlayer.defaults = {
        containerStyle: {
            position: "relative"
        },
        initLayout: true,
        originLeft: true,
        originTop: true,
        resize: true,
        resizeContainer: true,
        transitionDuration: "0.4s",
        hiddenStyle: {
            opacity: 0,
            transform: "scale(0.001)"
        },
        visibleStyle: {
            opacity: 1,
            transform: "scale(1)"
        }
    };
    var proto = Outlayer.prototype;
    function subclass(Parent) {
        function SubClass() {
            Parent.apply(this, arguments);
        }
        return SubClass.prototype = Object.create(Parent.prototype), SubClass.prototype.constructor = SubClass, 
        SubClass;
    }
    utils.extend(proto, EvEmitter.prototype), proto.option = function(opts) {
        utils.extend(this.options, opts);
    }, proto._getOption = function(option) {
        var oldOption = this.constructor.compatOptions[option];
        return oldOption && void 0 !== this.options[oldOption] ? this.options[oldOption] : this.options[option];
    }, Outlayer.compatOptions = {
        initLayout: "isInitLayout",
        horizontal: "isHorizontal",
        layoutInstant: "isLayoutInstant",
        originLeft: "isOriginLeft",
        originTop: "isOriginTop",
        resize: "isResizeBound",
        resizeContainer: "isResizingContainer"
    }, proto._create = function() {
        this.reloadItems(), this.stamps = [], this.stamp(this.options.stamp), utils.extend(this.element.style, this.options.containerStyle);
        var canBindResize = this._getOption("resize");
        if (canBindResize) this.bindResize();
    }, proto.reloadItems = function() {
        this.items = this._itemize(this.element.children);
    }, proto._itemize = function(elems) {
        var itemElems = this._filterFindItemElements(elems);
        var Item = this.constructor.Item;
        var items = [];
        for (var i = 0; i < itemElems.length; i++) {
            var elem = itemElems[i];
            var item = new Item(elem, this);
            items.push(item);
        }
        return items;
    }, proto._filterFindItemElements = function(elems) {
        return utils.filterFindElements(elems, this.options.itemSelector);
    }, proto.getItemElements = function() {
        return this.items.map(function(item) {
            return item.element;
        });
    }, proto.layout = function() {
        this._resetLayout(), this._manageStamps();
        var layoutInstant = this._getOption("layoutInstant");
        var isInstant = void 0 !== layoutInstant ? layoutInstant : !this._isLayoutInited;
        this.layoutItems(this.items, isInstant), this._isLayoutInited = true;
    }, proto._init = proto.layout, proto._resetLayout = function() {
        this.getSize();
    }, proto.getSize = function() {
        this.size = getSize(this.element);
    }, proto._getMeasurement = function(measurement, size) {
        var option = this.options[measurement];
        var elem;
        if (!option) this[measurement] = 0; else {
            if ("string" == typeof option) elem = this.element.querySelector(option); else if (option instanceof HTMLElement) elem = option;
            this[measurement] = elem ? getSize(elem)[size] : option;
        }
    }, proto.layoutItems = function(items, isInstant) {
        items = this._getItemsForLayout(items), this._layoutItems(items, isInstant), this._postLayout();
    }, proto._getItemsForLayout = function(items) {
        return items.filter(function(item) {
            return !item.isIgnored;
        });
    }, proto._layoutItems = function(items, isInstant) {
        if (this._emitCompleteOnItems("layout", items), items && items.length) {
            var queue = [];
            items.forEach(function(item) {
                var position = this._getItemLayoutPosition(item);
                position.item = item, position.isInstant = isInstant || item.isLayoutInstant, queue.push(position);
            }, this), this._processLayoutQueue(queue);
        }
    }, proto._getItemLayoutPosition = function() {
        return {
            x: 0,
            y: 0
        };
    }, proto._processLayoutQueue = function(queue) {
        this.updateStagger(), queue.forEach(function(obj, i) {
            this._positionItem(obj.item, obj.x, obj.y, obj.isInstant, i);
        }, this);
    }, proto.updateStagger = function() {
        var stagger = this.options.stagger;
        if (null === stagger || void 0 === stagger) return this.stagger = 0, void 0; else return this.stagger = getMilliseconds(stagger), 
        this.stagger;
    }, proto._positionItem = function(item, x, y, isInstant, i) {
        if (isInstant) item.goTo(x, y); else item.stagger(i * this.stagger), item.moveTo(x, y);
    }, proto._postLayout = function() {
        this.resizeContainer();
    }, proto.resizeContainer = function() {
        var isResizingContainer = this._getOption("resizeContainer");
        if (isResizingContainer) {
            var size = this._getContainerSize();
            if (size) this._setContainerMeasure(size.width, true), this._setContainerMeasure(size.height, false);
        }
    }, proto._getContainerSize = noop, proto._setContainerMeasure = function(measure, isWidth) {
        if (void 0 !== measure) {
            var elemSize = this.size;
            if (elemSize.isBorderBox) measure += isWidth ? elemSize.paddingLeft + elemSize.paddingRight + elemSize.borderLeftWidth + elemSize.borderRightWidth : elemSize.paddingBottom + elemSize.paddingTop + elemSize.borderTopWidth + elemSize.borderBottomWidth;
            measure = Math.max(measure, 0), this.element.style[isWidth ? "width" : "height"] = measure + "px";
        }
    }, proto._emitCompleteOnItems = function(eventName, items) {
        var _this = this;
        function onComplete() {
            _this.dispatchEvent(eventName + "Complete", null, [ items ]);
        }
        var count = items.length;
        if (!items || !count) return onComplete(), void 0;
        var doneCount = 0;
        function tick() {
            if (doneCount++, doneCount == count) onComplete();
        }
        items.forEach(function(item) {
            item.once(eventName, tick);
        });
    }, proto.dispatchEvent = function(type, event, args) {
        var emitArgs = event ? [ event ].concat(args) : args;
        if (this.emitEvent(type, emitArgs), jQuery) if (this.$element = this.$element || jQuery(this.element), 
        event) {
            var $event = jQuery.Event(event);
            $event.type = type, this.$element.trigger($event, args);
        } else this.$element.trigger(type, args);
    }, proto.ignore = function(elem) {
        var item = this.getItem(elem);
        if (item) item.isIgnored = true;
    }, proto.unignore = function(elem) {
        var item = this.getItem(elem);
        if (item) delete item.isIgnored;
    }, proto.stamp = function(elems) {
        if (elems = this._find(elems), elems) this.stamps = this.stamps.concat(elems), elems.forEach(this.ignore, this);
    }, proto.unstamp = function(elems) {
        if (elems = this._find(elems), elems) elems.forEach(function(elem) {
            utils.removeFrom(this.stamps, elem), this.unignore(elem);
        }, this);
    }, proto._find = function(elems) {
        if (elems) {
            if ("string" == typeof elems) elems = this.element.querySelectorAll(elems);
            return elems = utils.makeArray(elems), elems;
        }
    }, proto._manageStamps = function() {
        if (this.stamps && this.stamps.length) this._getBoundingRect(), this.stamps.forEach(this._manageStamp, this);
    }, proto._getBoundingRect = function() {
        var boundingRect = this.element.getBoundingClientRect();
        var size = this.size;
        this._boundingRect = {
            left: boundingRect.left + size.paddingLeft + size.borderLeftWidth,
            top: boundingRect.top + size.paddingTop + size.borderTopWidth,
            right: boundingRect.right - (size.paddingRight + size.borderRightWidth),
            bottom: boundingRect.bottom - (size.paddingBottom + size.borderBottomWidth)
        };
    }, proto._manageStamp = noop, proto._getElementOffset = function(elem) {
        var boundingRect = elem.getBoundingClientRect();
        var thisRect = this._boundingRect;
        var size = getSize(elem);
        var offset = {
            left: boundingRect.left - thisRect.left - size.marginLeft,
            top: boundingRect.top - thisRect.top - size.marginTop,
            right: thisRect.right - boundingRect.right - size.marginRight,
            bottom: thisRect.bottom - boundingRect.bottom - size.marginBottom
        };
        return offset;
    }, proto.handleEvent = utils.handleEvent, proto.bindResize = function() {
        window.addEventListener("resize", this), this.isResizeBound = true;
    }, proto.unbindResize = function() {
        window.removeEventListener("resize", this), this.isResizeBound = false;
    }, proto.onresize = function() {
        this.resize();
    }, utils.debounceMethod(Outlayer, "onresize", 100), proto.resize = function() {
        if (this.isResizeBound && this.needsResizeLayout()) this.layout();
    }, proto.needsResizeLayout = function() {
        var size = getSize(this.element);
        var hasSizes = this.size && size;
        return hasSizes && size.innerWidth !== this.size.innerWidth;
    }, proto.addItems = function(elems) {
        var items = this._itemize(elems);
        if (items.length) this.items = this.items.concat(items);
        return items;
    }, proto.appended = function(elems) {
        var items = this.addItems(elems);
        if (items.length) this.layoutItems(items, true), this.reveal(items);
    }, proto.prepended = function(elems) {
        var items = this._itemize(elems);
        if (items.length) {
            var previousItems = this.items.slice(0);
            this.items = items.concat(previousItems), this._resetLayout(), this._manageStamps(), 
            this.layoutItems(items, true), this.reveal(items), this.layoutItems(previousItems);
        }
    }, proto.reveal = function(items) {
        if (this._emitCompleteOnItems("reveal", items), items && items.length) {
            var stagger = this.updateStagger();
            items.forEach(function(item, i) {
                item.stagger(i * stagger), item.reveal();
            });
        }
    }, proto.hide = function(items) {
        if (this._emitCompleteOnItems("hide", items), items && items.length) {
            var stagger = this.updateStagger();
            items.forEach(function(item, i) {
                item.stagger(i * stagger), item.hide();
            });
        }
    }, proto.revealItemElements = function(elems) {
        var items = this.getItems(elems);
        this.reveal(items);
    }, proto.hideItemElements = function(elems) {
        var items = this.getItems(elems);
        this.hide(items);
    }, proto.getItem = function(elem) {
        for (var i = 0; i < this.items.length; i++) {
            var item = this.items[i];
            if (item.element == elem) return item;
        }
    }, proto.getItems = function(elems) {
        elems = utils.makeArray(elems);
        var items = [];
        return elems.forEach(function(elem) {
            var item = this.getItem(elem);
            if (item) items.push(item);
        }, this), items;
    }, proto.remove = function(elems) {
        var removeItems = this.getItems(elems);
        if (this._emitCompleteOnItems("remove", removeItems), removeItems && removeItems.length) removeItems.forEach(function(item) {
            item.remove(), utils.removeFrom(this.items, item);
        }, this);
    }, proto.destroy = function() {
        var style = this.element.style;
        style.height = "", style.position = "", style.width = "", this.items.forEach(function(item) {
            item.destroy();
        }), this.unbindResize();
        var id = this.element.outlayerGUID;
        if (delete instances[id], delete this.element.outlayerGUID, jQuery) jQuery.removeData(this.element, this.constructor.namespace);
    }, Outlayer.data = function(elem) {
        elem = utils.getQueryElement(elem);
        var id = elem && elem.outlayerGUID;
        return id && instances[id];
    }, Outlayer.create = function(namespace, options) {
        var Layout = subclass(Outlayer);
        if (Layout.defaults = utils.extend({}, Outlayer.defaults), utils.extend(Layout.defaults, options), 
        Layout.compatOptions = utils.extend({}, Outlayer.compatOptions), Layout.namespace = namespace, 
        Layout.data = Outlayer.data, Layout.Item = subclass(Item), utils.htmlInit(Layout, namespace), 
        jQuery && jQuery.bridget) jQuery.bridget(namespace, Layout);
        return Layout;
    };
    var msUnits = {
        ms: 1,
        s: 1e3
    };
    function getMilliseconds(time) {
        if ("number" == typeof time) return time;
        var matches = time.match(/(^\d*\.?\d*)(\w*)/);
        var num = matches && matches[1];
        var unit = matches && matches[2];
        if (!num.length) return 0;
        num = parseFloat(num);
        var mult = msUnits[unit] || 1;
        return num * mult;
    }
    return Outlayer.Item = Item, Outlayer;
}), function(window, factory) {
    if ("function" == typeof define && define.amd) define([ "outlayer/outlayer", "get-size/get-size" ], factory); else if ("object" == typeof module && module.exports) module.exports = factory(require("outlayer"), require("get-size")); else window.Masonry = factory(window.Outlayer, window.getSize);
}(window, function factory(Outlayer, getSize) {
    var Masonry = Outlayer.create("masonry");
    Masonry.compatOptions.fitWidth = "isFitWidth";
    var proto = Masonry.prototype;
    return proto._resetLayout = function() {
        this.getSize(), this._getMeasurement("columnWidth", "outerWidth"), this._getMeasurement("gutter", "outerWidth"), 
        this.measureColumns(), this.colYs = [];
        for (var i = 0; i < this.cols; i++) this.colYs.push(0);
        this.maxY = 0, this.horizontalColIndex = 0;
    }, proto.measureColumns = function() {
        if (this.getContainerWidth(), !this.columnWidth) {
            var firstItem = this.items[0];
            var firstItemElem = firstItem && firstItem.element;
            this.columnWidth = firstItemElem && getSize(firstItemElem).outerWidth || this.containerWidth;
        }
        var columnWidth = this.columnWidth += this.gutter;
        var containerWidth = this.containerWidth + this.gutter;
        var cols = containerWidth / columnWidth;
        var excess = columnWidth - containerWidth % columnWidth;
        var mathMethod = excess && excess < 1 ? "round" : "floor";
        cols = Math[mathMethod](cols), this.cols = Math.max(cols, 1);
    }, proto.getContainerWidth = function() {
        var isFitWidth = this._getOption("fitWidth");
        var container = isFitWidth ? this.element.parentNode : this.element;
        var size = getSize(container);
        this.containerWidth = size && size.innerWidth;
    }, proto._getItemLayoutPosition = function(item) {
        item.getSize();
        var remainder = item.size.outerWidth % this.columnWidth;
        var mathMethod = remainder && remainder < 1 ? "round" : "ceil";
        var colSpan = Math[mathMethod](item.size.outerWidth / this.columnWidth);
        colSpan = Math.min(colSpan, this.cols);
        var colPosMethod = this.options.horizontalOrder ? "_getHorizontalColPosition" : "_getTopColPosition";
        var colPosition = this[colPosMethod](colSpan, item);
        var position = {
            x: this.columnWidth * colPosition.col,
            y: colPosition.y
        };
        var setHeight = colPosition.y + item.size.outerHeight;
        var setMax = colSpan + colPosition.col;
        for (var i = colPosition.col; i < setMax; i++) this.colYs[i] = setHeight;
        return position;
    }, proto._getTopColPosition = function(colSpan) {
        var colGroup = this._getTopColGroup(colSpan);
        var minimumY = Math.min.apply(Math, colGroup);
        return {
            col: colGroup.indexOf(minimumY),
            y: minimumY
        };
    }, proto._getTopColGroup = function(colSpan) {
        if (colSpan < 2) return this.colYs;
        var colGroup = [];
        var groupCount = this.cols + 1 - colSpan;
        for (var i = 0; i < groupCount; i++) colGroup[i] = this._getColGroupY(i, colSpan);
        return colGroup;
    }, proto._getColGroupY = function(col, colSpan) {
        if (colSpan < 2) return this.colYs[col];
        var groupColYs = this.colYs.slice(col, col + colSpan);
        return Math.max.apply(Math, groupColYs);
    }, proto._getHorizontalColPosition = function(colSpan, item) {
        var col = this.horizontalColIndex % this.cols;
        var isOver = colSpan > 1 && col + colSpan > this.cols;
        col = isOver ? 0 : col;
        var hasSize = item.size.outerWidth && item.size.outerHeight;
        return this.horizontalColIndex = hasSize ? col + colSpan : this.horizontalColIndex, 
        {
            col: col,
            y: this._getColGroupY(col, colSpan)
        };
    }, proto._manageStamp = function(stamp) {
        var stampSize = getSize(stamp);
        var offset = this._getElementOffset(stamp);
        var isOriginLeft = this._getOption("originLeft");
        var firstX = isOriginLeft ? offset.left : offset.right;
        var lastX = firstX + stampSize.outerWidth;
        var firstCol = Math.floor(firstX / this.columnWidth);
        firstCol = Math.max(0, firstCol);
        var lastCol = Math.floor(lastX / this.columnWidth);
        lastCol -= lastX % this.columnWidth ? 0 : 1, lastCol = Math.min(this.cols - 1, lastCol);
        var isOriginTop = this._getOption("originTop");
        var stampMaxY = (isOriginTop ? offset.top : offset.bottom) + stampSize.outerHeight;
        for (var i = firstCol; i <= lastCol; i++) this.colYs[i] = Math.max(stampMaxY, this.colYs[i]);
    }, proto._getContainerSize = function() {
        this.maxY = Math.max.apply(Math, this.colYs);
        var size = {
            height: this.maxY
        };
        if (this._getOption("fitWidth")) size.width = this._getContainerFitWidth();
        return size;
    }, proto._getContainerFitWidth = function() {
        var unusedCols = 0;
        var i = this.cols;
        for (;--i && 0 === this.colYs[i]; ) unusedCols++;
        return (this.cols - unusedCols) * this.columnWidth - this.gutter;
    }, proto.needsResizeLayout = function() {
        var previousWidth = this.containerWidth;
        return this.getContainerWidth(), previousWidth != this.containerWidth;
    }, Masonry;
});

var $ = jQuery.noConflict();

!function($) {
    var TOOLS = {
        StrToNumber: function(str) {
            var numb = str.match(/\d/g);
            return parseInt(numb.join(""));
        },
        isMobile: {
            Android: function() {
                return navigator.userAgent.match(/Android/i);
            },
            BlackBerry: function() {
                return navigator.userAgent.match(/BlackBerry/i);
            },
            iOS: function() {
                return navigator.userAgent.match(/iPhone|iPad|iPod/i);
            },
            Opera: function() {
                return navigator.userAgent.match(/Opera Mini/i);
            },
            Windows: function() {
                return navigator.userAgent.match(/IEMobile/i) || navigator.userAgent.match(/WPDesktop/i);
            },
            Size: function() {
                return window.innerWidth < 641 ? true : false;
            },
            any: function() {
                return this.Size() || this.Android() || this.BlackBerry() || this.iOS() || this.Opera() || this.Windows();
            }
        }
    };
    "use strict";
    var Elem = {
        Window: window,
        Document: $(document),
        Html: $("html"),
        Body: $("body"),
        Page: $("#page"),
        Header: $("#masthead"),
        Content: $("#content"),
        Sidebar: $(".sidebar"),
        Navbar: $(".navbar-header"),
        Navigation: $(".navigation")
    };
    var Header = function() {
        "use strict";
        this.HeaderWrap = $(".js_header"), this.HeaderBg = $(".js_header_bg"), this.TimelineAvatar = $(".js_timeline_avatar"), 
        this.TimelineLine = $(".js_timelineLine"), this.SiteBranding = $(".site-branding"), 
        this.ScrollTop = 0, this.AdminBar = $("#wpadminbar"), this.hasAdminBar = function() {
            return void 0, Elem.Body.hasClass("admin-bar");
        }, this.setClass = function(ScrollTop) {
            var _this = this;
            if (ScrollTop > _this.HeaderWrap.height()) Elem.Body.addClass("fixed-this"); else Elem.Body.removeClass("fixed-this");
        }, this.topSpace = function() {
            var _this = this;
            if (void 0, _this.hasAdminBar()) return 32; else return 0;
        }, this.RunScroll = function(ScrollTop) {
            var _this = this;
            if (ScrollTop < _this.HeaderWrap.height()) _this.HeaderBg.css("background-position", "center " + (_this.topSpace() + -.4 * ScrollTop) + "px"), 
            _this.TimelineAvatar.css("top", _this.topSpace() + _this.HeaderWrap.height() - 30 - ScrollTop + "px"), 
            _this.TimelineLine.css("top", _this.topSpace() + _this.HeaderWrap.height() + 50 + 20 - ScrollTop + "px"), 
            _this.SiteBranding.css({
                opacity: 1 - ScrollTop / _this.HeaderWrap.height(),
                transform: "scale(" + parseFloat(1 + ScrollTop / _this.HeaderWrap.height()) + ")",
                top: -.3 * ScrollTop + "px"
            }); else _this.TimelineAvatar.css("top", _this.topSpace() + -28 + "px"), _this.TimelineLine.css("top", _this.topSpace() + 72 + "px");
        }, this.HeaderScroll = function() {
            var _this = this;
            $(window).on("scroll", function() {
                event.preventDefault(), _this.ScrollTop = $(window).scrollTop(), _this.RunScroll(_this.ScrollTop), 
                _this.setClass(_this.ScrollTop);
            });
        }, this.init = function() {
            if (!TOOLS.isMobile.any()) this.setClass($(window).scrollTop()), this.RunScroll($(window).scrollTop()), 
            this.HeaderScroll();
        };
    };
    var TimeLine = function(config) {
        "use strict";
        config = config;
        this.config = config, this.cons = {
            TimeLineIndex: 1,
            CanLoadData: true,
            Type: config.timeline.load_more_type
        }, this.NextAjaxUrl = $(".posts-navigation .nav-previous a").attr("href"), this.WrapTimeline = $(".js_timeline"), 
        this.LoadMoreText = this.WrapTimeline.data("loadtext"), this.SetTimeLineIndex = function() {
            var _this = this;
            var _Regex = /\D\/\d/;
            function getPageNumber(str) {
                str = str.match(/\D\/\d/g)[0].split("/").join("");
                return TOOLS.StrToNumber(str);
            }
            if (_Regex.test(window.location.href)) _this.cons.TimeLineIndex = getPageNumber(window.location.href); else _this.cons.TimeLineIndex = 1;
        }, this.SetMoment = function(el) {
            el = $(el).find(".js_time_wrap .js_time_timeline"), el.time = el.attr("datetime"), 
            el.text(moment(el.time).endOf("day").fromNow());
        }, this.CreateTime = function(elem) {
            var _this = this;
            elem.each(function(index, el) {
                _this.SetMoment(el);
            });
        }, this.HideNavigation = function() {
            $(".posts-navigation").hide();
        }, this.TimeLineStart = function() {
            var _this = this;
            if (Elem.Body.addClass("timeline-init"), _this.WrapTimelineChild = _this.WrapTimeline.children(), 
            _this.CreateTime(_this.WrapTimelineChild), !TOOLS.isMobile.any()) _this.GridTimeLine = _this.WrapTimeline.masonry({
                itemSelector: ".js_post",
                layoutMode: "masonry",
                percentPosition: true,
                visibleStyle: false,
                hiddenStyle: false,
                masonry: {}
            }), _this.WrapTimeline.children(".js_post").each(function(index, el) {
                if (void 0, $(el).addClass("is-ready"), 0 == el.offsetLeft) $(el).addClass("is-left"); else $(el).addClass("is-right");
            });
        }, this.LoadingStatus = function(type) {
            if ("show" == type) Elem.Body.addClass("show-loading"); else Elem.Body.removeClass("show-loading");
        }, this.CreateLoading = function() {
            this.WrapTimeline.after('<div class="timeline-loader"><div class="timeline-loader-icon-wrap"><div class="timeline-loader-icon ionicons ion-load-b"></div></div></div>');
        }, this.CreateLine = function() {}, this.CallTimeLineData = function(url) {
            var _this = this;
            $.ajax({
                url: _this.NextAjaxUrl,
                type: "GET",
                dataType: "html",
                success: function(data) {
                    var _data = $(".js_timeline .js_post", data);
                    var _url = $(".posts-navigation .nav-previous a", data);
                    if (_this.NextAjaxUrl = _url.attr("href"), _this.cons.CanLoadData = true, "undefined" == _this.NextAjaxUrl || "undefined" == typeof _this.NextAjaxUrl) _this.cons.CanLoadData = false;
                    void 0, _this.LoadingStatus("hide"), _this.AppendTimeLine(_data);
                },
                error: function() {
                    _this.cons.CanLoadData = false, _this.LoadingStatus("hide");
                },
                beforeSend: function() {
                    _this.cons.CanLoadData = false, _this.LoadingStatus("show");
                }
            });
        }, this.AppendTimeLine = function(data) {
            var _this = this;
            if (!TOOLS.isMobile.any()) setTimeout(function() {
                _this.GridTimeLine.masonry("layout");
            }, 50), _this.GridTimeLine.append(data).masonry("appended", data), _this.GridTimeLine.on("layoutComplete", function(event, dt) {
                _this.WrapTimeline.children(".js_post").each(function(index, el) {
                    if (_this.SetMoment(el), $(el).addClass("is-ready"), 0 == el.offsetLeft) $(el).addClass("is-left").removeClass("is-right"); else $(el).addClass("is-right").removeClass("is-left");
                });
            }); else data.each(function(index, el) {
                _this.SetMoment(el), _this.WrapTimeline.append(el);
            });
        }, this.ScrollTimeLine = function() {
            var _this = this;
            _this.CreateLoading(), _this.HideNavigation(), $(window).scroll(function() {
                if ($(window).scrollTop() == $(document).height() - $(window).height()) if (_this.cons.CanLoadData) void 0, 
                _this.cons.TimeLineIndex++, _this.CallTimeLineData(); else void 0;
            });
        }, this.CreateBtnLoadMore = function() {
            this.WrapTimeline.after('<div class="timline-loadmore js_timeline_loadmore">' + this.LoadMoreText + "</div>");
        }, this.ClickLoadMore = function() {
            var _this = this;
            _this.CreateLoading(), _this.HideNavigation(), _this.CreateBtnLoadMore(), Elem.Body.on("click", ".js_timeline_loadmore", function(event) {
                if (event.preventDefault(), _this.cons.CanLoadData) void 0, _this.cons.TimeLineIndex++, 
                _this.CallTimeLineData(); else void 0;
            });
        }, this.init = function() {
            if (this.SetTimeLineIndex(), this.CreateLine(), this.TimeLineStart(), "infinite" == this.cons.Type) {
                if (void 0, this.WrapTimeline.length) this.ScrollTimeLine();
            } else if ("click" == this.cons.Type) if (this.WrapTimeline.length) this.ClickLoadMore();
            void 0;
        };
    };
    var Navigation = function() {
        "use strict";
        this.open = false, this.Action = function() {
            var _this = this;
            Elem.Body.on("click", ".js_navigation_action", function(event) {
                event.preventDefault(), _this.Toggle();
            });
        }, this.Toggle = function() {
            var _this = this;
            if (!Elem.Body.hasClass("open-main-navigation")) Elem.Body.addClass("open-main-navigation"), 
            _this.open = true; else Elem.Body.removeClass("open-main-navigation"), _this.open = false;
        }, this.ToggleSearch = function(Element) {
            var _this = this;
            if (!Elem.Body.hasClass("open-search-navigation")) Elem.Body.addClass("open-search-navigation"), 
            Element.parents(".main-navigation").find(".search-form .search-field").focus(), 
            _this.open = true; else Elem.Body.removeClass("open-search-navigation"), _this.open = false;
        }, this.ActionSearch = function() {
            var _this = this;
            Elem.Body.on("click", ".js_navigation_search_action", function(event) {
                event.preventDefault();
                var $this = $(this);
                _this.ToggleSearch($this);
            });
        }, this.init = function() {
            this.Action(), this.ActionSearch();
        };
    };
    var Sidebar = function() {
        "use strict";
        this.open = false, this.Action = function() {
            var _this = this;
            Elem.Body.on("click", ".js_sidebar_action", function(event) {
                event.preventDefault(), _this.Toggle();
            });
        }, this.Toggle = function() {
            var _this = this;
            if (!Elem.Body.hasClass("open-sidebar")) Elem.Body.addClass("open-sidebar"), _this.open = true; else Elem.Body.removeClass("open-sidebar"), 
            _this.open = false;
        }, this.init = function() {
            this.Action();
        };
    };
    var Single = function() {
        "use strict";
        this.WrapInputForm = function() {
            $(".comment-form-email, .comment-form-author, .comment-form-url").wrapAll('<div class="input-form-wrap clearfix"></div>');
        }, this.init = function() {
            this.WrapInputForm();
        };
    };
    var MobileMenu = function($) {
        "use strict";
        this.elem = $(".main-navigation"), this.Action = function() {
            Elem.Body.on("click", ".menu-item-has-children .js_toggle_menu", function(event) {
                event.preventDefault();
                var _this = $(this);
                if (_this = _this.parent(".menu-item-has-children"), !_this.hasClass("is-open")) _this.addClass("is-open").children("ul.sub-menu, ul.children").addClass("child-open").stop(true, true).slideDown("400", function() {}); else _this.removeClass("is-open").children("ul.sub-menu, ul.children").removeClass("child-open").stop(true, true).slideUp("400", function() {});
                return false;
            });
        }, this.init = function() {
            this.elem.find(".menu-item-has-children").prepend('<span class="js_toggle_menu toggle-menu"></span>'), 
            this.elem.removeClass("site-navigation").addClass("mobile-menu"), this.Action();
        }, this.reinit = function() {
            this.elem.addClass("site-navigation").removeClass("mobile-menu"), this.elem.find(".js_toggle_menu").remove();
        };
    };
    "use strict";
    var _Navigation = new Navigation();
    var _Single = new Single();
    var _Sidebar = new Sidebar();
    var _TimeLine = new TimeLine(indotimeline_config);
    var _Header = new Header();
    var _MobileMenu = new MobileMenu($);
    $(document).ready(function() {
        if (void 0, Elem.Body.addClass("itl-ready"), _TimeLine.init(), _Sidebar.init(), 
        _Header.init(), _Navigation.init(), _Single.init(), TOOLS.isMobile.any()) _MobileMenu.init();
    });
}(jQuery);