/*
** Instantly live-update customizer settings in the preview for improved user experience.
*/

(function( $ ) {

	var $body = $('body');

	// Header
	wp.customize( 'header_textcolor', function( value ) {
		value.bind( function( val ) {
			if ( 'blank' === val ) {
				$('.site-branding .site-title').hide();
				$('.site-branding .site-description').hide();
			} else {
				$('.site-branding .site-title').show();
				$('.site-branding .site-description').show();

				$('.site-branding').css( 'color', val );
			}
		});
	});

	// Title
	wp.customize( 'blogname', function( value ) {
		value.bind( function( val ) {
			$('.site-branding .site-title a').text(val);
		});
	});

	// Description
	wp.customize( 'blogdescription', function( value ) {
		value.bind( function( val ) {
			$('.site-branding .site-description').text(val);
		});
	});


	// Timeline Indicator
	wp.customize( "indotimeline_options[timeline_timeline_indicator]", function( value ) {
		value.bind( function( val ) {
			if ( val == "arrow") {
				$body.addClass('timeline-use-arrow');
				$body.removeClass('timeline-use-bullet');
			}else if( val == "bullet" ){
				$body.addClass('timeline-use-bullet');
				$body.removeClass('timeline-use-arrow');
			}else{
				$body.removeClass('timeline-use-arrow');
				$body.removeClass('timeline-use-bullet');
			}
		});
	});
	// Timeline Indicator
	wp.customize( "indotimeline_options[timeline_display_line]", function( value ) {
		value.bind( function( val ) {
			if ( val == "yes") {
				$body.removeClass('remove-timeline-line');
			}else{
				$body.addClass('remove-timeline-line');
			}
		});
	});



} )( jQuery );
