<?php
/**
 * The template for displaying search results pages
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/#search-result
 *
 * @package IndoTimeline
 */

get_header();
?>

	<section id="primary" class="content-area">
		<main id="main" class="site-main">

		<?php if ( have_posts() ) : ?>

			<div class="container">
				<header class="page-header timeline-header">
					<div class="timeline-header-inner">
						<h1 class="page-title">
						<?php
							/* translators: %s: search query. */
							printf( esc_html__( 'Search Results for: %s', 'indotimeline' ), '<span>' . get_search_query() . '</span>' );
						?>
						</h1>
					</div>
				</header><!-- .page-header -->

				<?php indotimeline_timeline_before() ?>

					<?php
					/* Start the Loop */
					while ( have_posts() ) :
						the_post();

						/**
						 * Run the loop for the search to output the results.
						 * If you want to overload this in a child theme then include a file
						 * called content-search.php and that will be used instead.
						 */
						get_template_part( 'template-parts/content', 'search' );

					endwhile;

					?>

				<?php indotimeline_timeline_after() ?>

			</div>
			<!-- /.container -->

			<?php

			the_posts_navigation();

		else :

			get_template_part( 'template-parts/content', 'none' );

		endif;
		?>

		</main><!-- #main -->
	</section><!-- #primary -->

<?php
get_sidebar();
get_footer();
