<?php
/**
 * The sidebar containing the main widget area
 *
 * @link https://developer.wordpress.org/themes/basics/template-files/#template-partials
 *
 * @package IndoTimeline
 */

if ( ! is_active_sidebar( 'sidebar-1' ) ) {
	return;
}
?>

<section class="sidebar link-inherit">
	<div class="close-mobile-btn js_sidebar_action">
		<i class="ionicons icon-gost ion-close itl-fz-23"></i>
	</div>
	<div class="sidebar-inner">
		<aside id="secondary" class="widget-area">
			<?php dynamic_sidebar( 'sidebar-1' ); ?>
		</aside><!-- #secondary -->
	</div>
	
	<footer id="colophon" class="site-footer">
		<div class="site-info">
			<a href="<?php echo esc_url( __( 'https://wordpress.org/', 'indotimeline' ) ); ?>">
				<?php
				/* translators: %s: CMS name, i.e. WordPress. */
				printf( esc_html__( 'Proudly powered by %s', 'indotimeline' ), 'WordPress' );
				?>
			</a>
			<span class="sep"> | </span>
				<?php
				/* translators: 1: Theme name, 2: Theme author. */
				printf( esc_html__( 'Theme: %1$s by %2$s.', 'indotimeline' ), 'IndoTimeline', '<a href="http://indodevapps.com">IndoDevApps</a>' );
				?>
		</div><!-- .site-info -->
	</footer><!-- #colophon -->
</section>
<!-- .sidebar -->